unit UnidadAparatos;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, inifiles,variants;

type
  TFormAparato = class(TForm)
    PopupMenu1: TPopupMenu;
    ActionList1: TActionList;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ActRefrescar: TAction;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ActCerrar: TAction;
    Tabla: TDBGrid;
    ActImprimir: TAction;
    Aadir1: TMenuItem;
    Eliminar1: TMenuItem;
    Modificar1: TMenuItem;
    N1: TMenuItem;
    Refrescar1: TMenuItem;
    N2: TMenuItem;
    Cerrar1: TMenuItem;
    ToolButton8: TToolButton;
    ActBuscar: TAction;
    ToolButton9: TToolButton;
    Buscar1: TMenuItem;
    Imprimir1: TMenuItem;
    ActZoom: TAction;
    ToolButton10: TToolButton;
    Zoom1: TMenuItem;
    ActPts: TAction;
    ActEuros: TAction;
    BPta: TToolButton;
    BEuro: TToolButton;
    ToolButton13: TToolButton;
    Pesetas1: TMenuItem;
    Euros1: TMenuItem;
    N3: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActBuscarExecute(Sender: TObject);
    procedure ActZoomExecute(Sender: TObject);
    procedure TablaTitleClick(Column: TColumn);

    procedure ordenar (campo : string; campoFijo : string);
    procedure ActPtsExecute(Sender: TObject);
    procedure ActEurosExecute(Sender: TObject);
    procedure MostrarEuros (Euros : boolean; m1, m2, m3, m4 : string;
       c1, c2, c3, c4 : integer);

  private
    campoOrdenado : string;
    nombreCampoOrdenado : string;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormAparato: TFormAparato;
const
  ventana = 'Aparato';
  ventanas = 'Aparatos';
  segCampo = 'Nombre';

implementation

uses UnidadMenuPrincipal, UnidadImprimir,
  UnidadLocalizar, UnidadDatos, UnidadGAparato;

{$R *.DFM}

var
  fp : tformmenuprincipal;

procedure tFormAparato.ordenar (campo : string; campoFijo : string);
var
  lugar : string;
begin
  lugar := '';
  with datos.tcaparato do
  begin
    if Active then
    begin
      Refresh;
      if RecordCount > 0 then
        lugar := fieldbyname('Codigo').value;
    end;
    close;
    sql.clear;
    sql.add ('SELECT *');
    sql.add ('FROM ' + ventana);
    sql.add ('ORDER BY ' + campo + ',' + campoFijo);
    try
  //  ExecSQL;
      open;
    except
      raise;
    end;
    if lugar <> '' then
      locate ('Codigo',lugar,[]);
  end;
end;

procedure TFormAparato.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  i:integer;
begin
  //Guardar el ancho de las columnas y configuracin
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    WriteString('Tabla ' + ventanas, cCLugar, datos.TCAparatoCodigo.value);
    Writestring('Tabla ' + ventanas, cCMoneda, tabla.Columns[2].FieldName);
    writestring('Tabla ' + ventanas, cCOrdenar, campoOrdenado);
    writestring('Tabla ' + ventanas, ccTituloOrdenar, nombreCampoOrdenado);
    for I := 0 to tabla.Columns.Count - 1 do
    begin
      with tabla.Columns.Items[I] do
        WriteInteger('Tabla ' + ventanas, FieldName, Width);
    end;
  finally
    Free;
  end;
  try
   datos.TCAparato.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TFormAparato.MostrarEuros (Euros : boolean; m1, m2, m3, m4 : string;
    c1, c2, c3, c4 : integer);
begin
  ActEuros.Checked := euros;
  ActPts.Checked := not euros;
  Tabla.Columns[c1].FieldName := m1;
  if m2 <> '' then
    Tabla.Columns[c2].FieldName := m2;
  if m3 <> '' then
    Tabla.Columns[c3].FieldName := m3;
  if m4 <> '' then
    Tabla.Columns[c4].FieldName := m4;
end;


procedure TFormAparato.FormShow(Sender: TObject);
var
  I : Integer;
  moneda, lugar : string;
begin
  cb.visible := formmenuprincipal.vtmostrarbbventanas;
  bb.flat := formmenuprincipal.vtflat;

  if FormMenuPrincipal.leBoolINI ('Aplicacion', cGuardarVentanas, false) then
  begin
    with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
    try
      lugar := readString('Tabla ' + ventanas, cclugar, '0');
      moneda := readstring('Tabla ' + ventanas, ccmoneda, 'Importe');
      campoOrdenado := readstring('Tabla ' + ventanas, ccordenar, 'Codigo');
      nombreCampoOrdenado := readstring('Tabla ' + ventanas, ccTituloOrdenar, 'Cdigo');
      if campoOrdenado = '' then
        campoOrdenado := 'Codigo';
      if nombreCampoOrdenado = '' then
        nombreCampoOrdenado := 'Cdigo';
      if moneda = '' then
        moneda := 'Importe';
    finally
      Free;
    end;

    ordenar(campoOrdenado, segCampo);
    Datos.TCAparato.Locate ('Codigo', lugar, []);

    if uppercase(moneda) = uppercase('ImporteComision') then
      MostrarEuros (false, 'ImporteComision', 'ImporteVenta',
          'ImporteCompra', '', 2, 4, 5, 0)
    else
      MostrarEuros (true, 'ImporteComisionE', 'ImporteVentaE',
          'ImporteCompraE', '', 2, 4, 5, 0)
  end
  else
  begin
    campoOrdenado := 'Codigo';
    ordenar(campoOrdenado, segCampo);
    nombreCampoOrdenado := 'Cdigo';
    if FormMenuPrincipal.leBoolINI ('Aplicacion', cMostrarEuros, false) then  //Euros
      MostrarEuros (true, 'ImporteComisionE', 'ImporteVentaE',
          'ImporteCompraE', '', 2, 4, 5, 0)
    else
      MostrarEuros (false, 'ImporteComision', 'ImporteVenta',
          'ImporteCompra', '', 2, 4, 5, 0);
  end;

  //ancho de columnas
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    for I := 0 to tabla.Columns.Count - 1 do
      with tabla.Columns.Items[I] do
        Width := ReadInteger('Tabla ' + ventanas, FieldName, Width);
  finally
    Free;
  end;
  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas + ' (ordenado por ' + nombrecampoordenado + ')';
  screen.cursor := crdefault;
end;

procedure TFormAparato.ActNuevoExecute(Sender: TObject);
begin
  if fp.ComprobarUsuario('altas/bajas', false) then
  begin
    formmenuprincipal.accion := 'nuevo';
    application.createform(tformaparatog, formaparatog);
    formaparatog.ShowModal;
    ActRefrescarExecute(nil);
  end;
end;

procedure TFormAparato.ActEliminarExecute(Sender: TObject);
var
  nombre : String;
begin
  if datos.TCAparato.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario('altas/bajas', false) then
    begin
      datos.tc.close;
      datos.tc.DatabaseName := 'Comisiones';
      datos.tc.sql.clear;
      datos.tc.sql.add('SELECT CodigoAparato');
      datos.tc.sql.add('FROM Venta');
      datos.tc.sql.add('WHERE CodigoAparato = "' + datos.TCAparatoCodigo.value + '"');
      datos.tc.open;
      if datos.tc.RecordCount > 0 then
      begin
        datos.tc.close;
        fp.msInfo ('No se puede eliminar el ' + ventana +
            ' ya que existen Ventas a su nombre.', 'Informacin...');
        exit;
      end;
      datos.tc.close;
      datos.TAparato.Active := true;
      datos.TAparato.locate('Codigo',
          datos.TCAparato.fieldbyname('Codigo').value, []);
      if not varisnull(datos.TAparatoNombre.Value) then
        nombre := datos.TAparatoNombre.Value
      else
        nombre := '';
      if fp.msSi ('Est seguro que desea eliminar el ' + ventana + ': ' +
          nombre + '?', 'Eliminar ' + ventana + '...') then
      begin
        try
          datos.TAparato.delete;
          ActRefrescarExecute(nil);
        except
          raise;
        end;
      end;
    end;
  end;
end;

procedure TFormAparato.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure TFormAparato.ActModificarExecute(Sender: TObject);
begin
  if datos.TCAparato.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario('modificacion', false) then
    begin
      if not varisnull(datos.TCAparato.fieldbyname('Codigo').value) then
      begin
        formmenuprincipal.accion := 'modificar';
        datos.taparato.open;
        datos.TAparato.locate ('Codigo',
            datos.TCAparato.fieldbyname('Codigo').value,[]);
        datos.TAparato.edit;
        application.createform(tformaparatog, formaparatog);
        formaparatog.ShowModal;
        ActRefrescarExecute(nil);        
      end
      else
        fp.msError ('Atencin, el ' + ventana + ' actual no tiene cdigo, ' +
            'elimnelo antes de continuar.','Error...');
    end;
  end;
end;

procedure TFormAparato.TablaDblClick(Sender: TObject);
begin
  ActModificarExecute(nil);
end;

procedure TFormAparato.ActRefrescarExecute(Sender: TObject);
begin
  ordenar(campoOrdenado, segCampo);
end;

procedure TFormAparato.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TFormAparato.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TFormAparato.ActImprimirExecute(Sender: TObject);
begin
  if datos.TCAparato.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario ('localizar', false) then
    begin
      application.createform(tformImprimir, formImprimir);
      formimprimir.Tag := 30;
      formImprimir.showmodal;
    end;
  end;
end;

procedure TFormAparato.ActBuscarExecute(Sender: TObject);
begin
  if datos.TCAparato.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if  fp.ComprobarUsuario ('localizar', false) then
    begin
      application.createform(tformLocalizar, formLocalizar);
      FormLocalizar.Tag := 30;
      formLocalizar.showmodal;
    end;
  end;
end;

procedure TFormAparato.ActZoomExecute(Sender: TObject);
begin
  if datos.TCAparato.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario('zoom', false) then
    begin
      formmenuprincipal.accion := 'zoom';
      formmenuprincipal.codigo := datos.tcaparato.fieldbyname('Codigo').value;
      application.createform(tformaparatog, formaparatog);
      formaparatog.ShowModal;
    end;
  end;
end;

procedure TFormAparato.TablaTitleClick(Column: TColumn);
begin
  campoOrdenado := column.fieldname;
  nombreCampoOrdenado := Column.Title.Caption;
  caption := ventanas + ' (ordenado por ' + Column.Title.Caption + ')';
  ordenar (campoOrdenado, segCampo);
end;

procedure TFormAparato.ActPtsExecute(Sender: TObject);
begin
  if ActEuros.Checked then
    MostrarEuros (false, 'ImporteComision', 'ImporteVenta',
        'ImporteCompra', '', 2, 4, 5, 0)
  else
    MostrarEuros (true, 'ImporteComisionE', 'ImporteVentaE',
        'ImporteCompraE', '', 2, 4, 5, 0)
end;

procedure TFormAparato.ActEurosExecute(Sender: TObject);
begin

  if ActEuros.Checked then
    MostrarEuros (false, 'ImporteComision', 'ImporteVenta',
        'ImporteCompra', '', 2, 4, 5, 0)
  else
    MostrarEuros (true, 'ImporteComisionE', 'ImporteVentaE',
        'ImporteCompraE', '', 2, 4, 5, 0)
end;

end.
