unit UnidadComerciales;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, inifiles,variants;

type
  TFormComercial = class(TForm)
    PopupMenu1: TPopupMenu;
    ActionList1: TActionList;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ActRefrescar: TAction;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ActCerrar: TAction;
    Tabla: TDBGrid;
    ActImprimir: TAction;
    Aadir1: TMenuItem;
    Eliminar1: TMenuItem;
    Modificar1: TMenuItem;
    N1: TMenuItem;
    Refrescar1: TMenuItem;
    N2: TMenuItem;
    Cerrar1: TMenuItem;
    ToolButton8: TToolButton;
    ActBuscar: TAction;
    ToolButton9: TToolButton;
    Buscar1: TMenuItem;
    Imprimir1: TMenuItem;
    ActZoom: TAction;
    ToolButton10: TToolButton;
    Zoom1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActBuscarExecute(Sender: TObject);
    procedure ActZoomExecute(Sender: TObject);
    procedure TablaTitleClick(Column: TColumn);

    procedure ordenar (campo : string; campoFijo : string);


  private
    campoOrdenado : string;
    nombreCampoOrdenado : string;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormComercial: TFormComercial;
const
  ventana = 'Comercial';
  ventanas = 'Comerciales';
  segCampo = 'Nombre';

implementation

uses UnidadMenuPrincipal, UnidadImprimir,
  UnidadLocalizar, UnidadDatos, UnidadGComerial;

{$R *.DFM}

var
  fp : tformmenuprincipal;

procedure tformcomercial.ordenar (campo : string; campoFijo : string);
var
  lugar : string;
begin
  lugar := '';
  with datos.tccomercial do
  begin
    if Active then
    begin
      Refresh;
      if RecordCount > 0 then
        lugar := fieldbyname('Codigo').value;
    end;
    close;
    sql.clear;
    sql.add ('SELECT *');
    sql.add ('FROM ' + ventana);
    sql.add ('ORDER BY ' + campo + ',' + campoFijo);
    try
      open;
  //  ExecSQL;
    except
      raise;
    end;
    if lugar <> '' then
      locate ('Codigo',lugar,[]);
  end;
end;

procedure TFormComercial.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  i:integer;
begin
  //Guardar el ancho de las columnas y configuracin
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    WriteString('Tabla ' + ventanas, cCLugar, datos.TCComercialCodigo.value);
    writestring('Tabla ' + ventanas, cCOrdenar, campoOrdenado);
    writestring('Tabla ' + ventanas, ccTituloOrdenar, nombreCampoOrdenado);
    for I := 0 to tabla.Columns.Count - 1 do
    begin
      with tabla.Columns.Items[I] do
        WriteInteger('Tabla ' + ventanas, FieldName, Width);
    end;
  finally
    Free;
  end;
  try
   datos.TCComercial.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TFormComercial.FormShow(Sender: TObject);
var
  I : Integer;
  lugar : string;
begin
  cb.visible := formmenuprincipal.vtmostrarbbventanas;
  bb.flat := formmenuprincipal.vtflat;

  //si hay que restablecer la ventana segn la ltima vez
  if FormMenuPrincipal.leBoolINI ('Aplicacion', cGuardarVentanas, false) then
  begin
    with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
    try
      lugar := readString('Tabla ' + ventanas, cclugar, '0');
      campoOrdenado := readstring('Tabla ' + ventanas, ccordenar, 'Codigo');
      nombreCampoOrdenado := readstring('Tabla ' + ventanas, ccTituloOrdenar, 'Cdigo');
      if campoOrdenado = '' then
        campoOrdenado := 'Codigo';
      if nombreCampoOrdenado = '' then
        nombreCampoOrdenado := 'Cdigo';
    finally
      Free;
    end;
    ordenar(campoOrdenado, segCampo);
    Datos.TCComercial.Locate ('Codigo', lugar, []);
  end
  else
  begin
    campoOrdenado := 'Codigo';
    ordenar(campoOrdenado, segCampo);
    nombreCampoOrdenado := 'Cdigo';
  end;

  //ancho de columnas
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    for I := 0 to tabla.Columns.Count - 1 do
      with tabla.Columns.Items[I] do
        Width := ReadInteger('Tabla ' + ventanas, FieldName, Width);
  finally
    Free;
  end;

  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas + ' (ordenado por ' + nombrecampoordenado + ')';
  screen.cursor := crdefault;
end;

procedure TFormComercial.ActNuevoExecute(Sender: TObject);
begin
  if fp.ComprobarUsuario('altas/bajas', false) then
  begin
    formmenuprincipal.accion := 'nuevo';
    application.createform(tformcomercialg, formcomercialg);
    formcomercialg.ShowModal;
    ActRefrescarExecute(nil);    
  end;
end;

procedure TFormComercial.ActEliminarExecute(Sender: TObject);
var
  nombre : String;
begin
  if datos.TCComercial.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario('altas/bajas', false) then
    begin
      datos.tc.close;
      datos.tc.DatabaseName := 'Comisiones';
      datos.tc.sql.clear;
      datos.tc.sql.add('SELECT CodigoComercial');
      datos.tc.sql.add('FROM Venta');
      datos.tc.sql.add('WHERE CodigoComercial = "' + datos.TCComercialCodigo.value + '"');
      datos.tc.open;
      if datos.tc.RecordCount > 0 then
      begin
        datos.tc.close;
        fp.msInfo ('No se puede eliminar el ' + ventana +
            ' ya que existen Ventas a su nombre.', 'Informacin...');
        exit;
      end;
      datos.tc.close;
      datos.tc.sql.clear;
      datos.tc.sql.add('SELECT CodigoComercial');
      datos.tc.sql.add('FROM Cobro');
      datos.tc.sql.add('WHERE CodigoComercial = "' + datos.TCComercialCodigo.value + '"');
      datos.tc.open;
      if datos.tc.RecordCount > 0 then
      begin
        datos.tc.close;
        fp.msInfo ('No se puede eliminar el ' + ventana +
            ' ya que existen Cobros a su nombre.', 'Informacin...');
        exit;
      end;
      datos.tc.close;
      datos.tc.sql.clear;
      datos.tc.sql.add('SELECT CodigoComercial');
      datos.tc.sql.add('FROM Gasto');
      datos.tc.sql.add('WHERE CodigoComercial = "' + datos.TCComercialCodigo.value + '"');
      datos.tc.open;
      if datos.tc.RecordCount > 0 then
      begin
        datos.tc.close;
        fp.msInfo ('No se puede eliminar el ' + ventana +
            ' ya que existen Gastos a su nombre.', 'Informacin...');
        exit;
      end;
      datos.tc.close;
      datos.tc.sql.clear;
      datos.tc.sql.add('SELECT CodigoComercial');
      datos.tc.sql.add('FROM Extra');
      datos.tc.sql.add('WHERE CodigoComercial = "' + datos.TCComercialCodigo.value + '"');
      datos.tc.open;
      if datos.tc.RecordCount > 0 then
      begin
        datos.tc.close;
        fp.msInfo ('No se puede eliminar el ' + ventana +
            ' ya que existen Extras a su nombre.', 'Informacin...');
        exit;
      end;
      datos.tc.close;
      datos.tc.sql.clear;
      datos.tc.sql.add('SELECT CodigoComercial');
      datos.tc.sql.add('FROM Factura');
      datos.tc.sql.add('WHERE CodigoComercial = "' + datos.TCComercialCodigo.value + '"');
      datos.tc.open;
      if datos.tc.RecordCount > 0 then
      begin
        datos.tc.close;
        fp.msInfo ('No se puede eliminar el ' + ventana +
            ' ya que existen Facturas a su nombre.', 'Informacin...');
        exit;
      end;
      datos.tc.close;
      datos.TComercial.Active := true;
      datos.tcomercial.locate('Codigo',
          datos.TCComercial.fieldbyname('Codigo').value, []);
      if not varisnull(datos.TComercialNombre.Value) then
        nombre := datos.TComercialNombre.Value
      else
        nombre := '';
      if fp.msSi ('Est seguro que desea eliminar el ' + ventana + ' : ' +
          nombre + '?', 'Eliminar ' + ventana + '...') then
      begin
        try
          datos.TComercial.delete;
          ActRefrescarExecute(nil);
        except
          raise;
        end;
      end;
    end;
  end;
end;

procedure TFormComercial.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure TFormComercial.ActModificarExecute(Sender: TObject);
begin
  if datos.TCComercial.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario('modificacion', false) then
    begin
      if not varisnull(datos.tccomercial.fieldbyname('Codigo').value) then
      begin
        formmenuprincipal.accion := 'modificar';
        datos.tcomercial.Active := true;
        datos.tcomercial.locate ('Codigo',
            datos.tccomercial.fieldbyname('Codigo').value,[]);
        datos.TComercial.edit;
        application.createform(tformcomercialg, formcomercialg);
        formcomercialg.ShowModal;
        ActRefrescarExecute(nil);        
      end
      else
        fp.msError ('Atencin, el ' + ventana + ' actual no tiene cdigo, ' +
            'elimnelo antes de continuar.','Error...');
    end;
  end;
end;

procedure TFormComercial.TablaDblClick(Sender: TObject);
begin
  ActModificarExecute(nil);
end;

procedure TFormComercial.ActRefrescarExecute(Sender: TObject);
begin
  ordenar(campoOrdenado, segCampo);
end;

procedure TFormComercial.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TFormComercial.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TFormComercial.ActImprimirExecute(Sender: TObject);
begin
  if datos.TCComercial.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario ('localizar', false) then
    begin
      application.createform(tformImprimir, formImprimir);
      formimprimir.Tag := 10;
      formImprimir.showmodal;
    end;
  end;
end;

procedure TFormComercial.ActBuscarExecute(Sender: TObject);
begin
  if datos.TCComercial.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if  fp.ComprobarUsuario ('localizar', false) then
    begin
      application.createform(tformLocalizar, formLocalizar);
      FormLocalizar.Tag := 10;
      formLocalizar.showmodal;
    end;
  end;
end;

procedure TFormComercial.ActZoomExecute(Sender: TObject);
begin
  if datos.TCComercial.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario('zoom', false) then
    begin
      formmenuprincipal.accion := 'zoom';
      formmenuprincipal.codigo := datos.tccomercial.fieldbyname('Codigo').value;
      application.createform(tformcomercialg, formcomercialg);
      formcomercialg.ShowModal;
    end;
  end;
end;

procedure TFormComercial.TablaTitleClick(Column: TColumn);
begin
  campoOrdenado := column.fieldname;
  nombreCampoOrdenado := Column.Title.Caption;
  caption := ventanas + ' (ordenado por ' + Column.Title.Caption + ')';
  ordenar (campoOrdenado, segCampo);
end;

end.
