unit UnidadComercialesGastos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, inifiles,variants;

type
  tformcomercialgasto = class(TForm)
    PopupMenu1: TPopupMenu;
    ActionList1: TActionList;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ActRefrescar: TAction;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ActCerrar: TAction;
    Tabla: TDBGrid;
    ActImprimir: TAction;
    Aadir1: TMenuItem;
    Eliminar1: TMenuItem;
    Modificar1: TMenuItem;
    N1: TMenuItem;
    Refrescar1: TMenuItem;
    N2: TMenuItem;
    Cerrar1: TMenuItem;
    ToolButton8: TToolButton;
    ActBuscar: TAction;
    ToolButton9: TToolButton;
    Buscar1: TMenuItem;
    Imprimir1: TMenuItem;
    ActZoom: TAction;
    ToolButton10: TToolButton;
    Zoom1: TMenuItem;
    ActPts: TAction;
    ActEuros: TAction;
    BPta: TToolButton;
    BEuro: TToolButton;
    ToolButton13: TToolButton;
    N3: TMenuItem;
    Pesetas1: TMenuItem;
    Euros1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActBuscarExecute(Sender: TObject);
    procedure ActZoomExecute(Sender: TObject);
    procedure TablaTitleClick(Column: TColumn);

    procedure ordenar (campo : string; campoFijo : string);
    procedure ActPtsExecute(Sender: TObject);
    procedure BEuroClick(Sender: TObject);
    procedure MostrarEuros (Euros : boolean; m1, m2, m3, m4 : string;
       c1, c2, c3, c4 : integer);
    procedure ActEurosExecute(Sender: TObject);

  private
    campoOrdenado : string;
    nombreCampoOrdenado : string;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormComercialGasto: tformcomercialgasto;
const
  ventana = 'Gasto';
  ventanas = 'Gastos';
  segCampo = 'Comercial';

implementation

uses UnidadMenuPrincipal, UnidadImprimir,
  UnidadLocalizar, UnidadDatos, UnidadGGastoComercial;

{$R *.DFM}

var
  fp : tformmenuprincipal;

procedure tformcomercialgasto.ordenar (campo : string; campoFijo : string);
var
  lugar : string;
begin
  lugar := '';
  With datos.TCComercialGasto do
  begin
    if Active then
    begin
      Refresh;
      if RecordCount > 0 then
        lugar := fieldbyname('Codigo').value;
    end;
    close;
    sql.clear;
    sql.add('SELECT  c.*, co.Nombre Comercial');
    sql.add('FROM ' + ventana + ' c, comercial co');
    sql.add('WHERE c.codigoComercial = co.Codigo');
    sql.add('ORDER BY ' + campo + ',' + campoFijo);
    try
      open;
   // ExecSQL;
    except
      raise;
    end;
    if lugar <> '' then
      locate ('Codigo', lugar,[]);
  end;
end;

procedure tformcomercialgasto.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  i:integer;
begin
  //Guardar el ancho de las columnas y configuracin
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    WriteString('Tabla ' + ventanas, cCLugar, inttostr(datos.TCComercialGastoCodigo.value));
    Writestring('Tabla ' + ventanas, cCMoneda, tabla.Columns[4].FieldName);
    writestring('Tabla ' + ventanas, cCOrdenar, campoOrdenado);
    writestring('Tabla ' + ventanas, ccTituloOrdenar, nombreCampoOrdenado);
    for I := 0 to tabla.Columns.Count - 1 do
    begin
      with tabla.Columns.Items[I] do
        WriteInteger('Tabla ' + ventanas, FieldName, Width);
    end;
  finally
    Free;
  end;
  try
   datos.TCComercialGasto.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TFormComercialGasto.MostrarEuros (Euros : boolean; m1, m2, m3, m4 : string;
    c1, c2, c3, c4 : integer);
begin
  ActEuros.Checked := euros;
  ActPts.Checked := not euros;
  Tabla.Columns[c1].FieldName := m1;
  if m2 <> '' then
    Tabla.Columns[c2].FieldName := m2;
  if m3 <> '' then
    Tabla.Columns[c3].FieldName := m3;
  if m4 <> '' then
    Tabla.Columns[c4].FieldName := m4;
end;

procedure tformcomercialgasto.FormShow(Sender: TObject);
var
  I : Integer;
  moneda, lugar : string;
begin
  cb.visible := formmenuprincipal.vtmostrarbbventanas;
  bb.flat := formmenuprincipal.vtflat;

  //si hay que restablecer la ventana segn la ltima vez
  if FormMenuPrincipal.leBoolINI ('Aplicacion', cGuardarVentanas, false) then
  begin
    with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
    try
      lugar := readString('Tabla ' + ventanas, cclugar, '0');
      moneda := readstring('Tabla ' + ventanas, ccmoneda, 'Importe');
      campoOrdenado := readstring('Tabla ' + ventanas, ccordenar, 'Codigo');
      nombreCampoOrdenado := readstring('Tabla ' + ventanas, ccTituloOrdenar, 'Cdigo');
      if campoOrdenado = '' then
        campoOrdenado := 'Codigo';
      if nombreCampoOrdenado = '' then
        nombreCampoOrdenado := 'Cdigo';
      if moneda = '' then
        moneda := 'Importe';
    finally
      Free;
    end;

    ordenar(campoOrdenado, segCampo);
    Datos.TCComercialGasto.Locate ('Codigo', lugar, []);

    if uppercase(moneda) = uppercase('Importe') then
      MostrarEuros (false, 'Importe', '', '', '', 4, 0, 0, 0)
    else
      MostrarEuros (true, 'ImporteE', '', '', '', 4, 0, 0, 0);
  end
  else
  begin
    campoOrdenado := 'Codigo';
    ordenar(campoOrdenado, segCampo);
    nombreCampoOrdenado := 'Cdigo';
    if FormMenuPrincipal.leBoolINI ('Aplicacion', cMostrarEuros, false) then  //Euros
      MostrarEuros (true, 'ImporteE', '', '', '', 4, 0, 0, 0)
    else
      MostrarEuros (false, 'Importe', '', '', '', 4, 0, 0, 0);
  end;

  //ancho de columnas
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    for I := 0 to tabla.Columns.Count - 1 do
      with tabla.Columns.Items[I] do
        Width := ReadInteger('Tabla ' + ventanas, FieldName, Width);
  finally
    Free;
  end;

  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas + ' (ordenado por ' + nombrecampoordenado + ')';
  screen.cursor := crdefault;
end;

procedure tformcomercialgasto.ActNuevoExecute(Sender: TObject);
begin
  if fp.ComprobarUsuario('altas/bajas', false) then
  begin
    formmenuprincipal.accion := 'nuevo';
    application.createform(tformcomercialgastog, formcomercialgastog);
    formcomercialgastog.ShowModal;
    ActRefrescarExecute(nil);    
  end;
end;

procedure tformcomercialgasto.ActEliminarExecute(Sender: TObject);
var
  nombre : String;
begin
  if datos.TCComercialGasto.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario('altas/bajas', false) then
    begin
      datos.TComercialGasto.Active := true;
      datos.TComercialGasto.locate('Codigo',
          datos.TCComercialGasto.fieldbyname('Codigo').value, []);
      if not varisnull(datos.TComercialGastoNombre.Value) then
        nombre := datos.TComercialGastoNombre.Value
      else
        nombre := '';
      if fp.msSi ('Est seguro que desea eliminar el ' + ventana + ' : ' +
          nombre + '?', 'Eliminar ' + ventana + '...') then
      begin
        //NO TERMINADO COMPROBAR SI ESTE COMERCIAL TIENE VENTAS
        //ELIMINAR LOS DETALLES (GASTOS)
        try
          datos.TComercialGasto.delete;
          ActRefrescarExecute(nil);
        except
          raise;
        end;
      end;
    end;
  end;
end;

procedure tformcomercialgasto.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure tformcomercialgasto.ActModificarExecute(Sender: TObject);
begin
  if datos.TCComercialGasto.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario('modificacion', false) then
    begin
      if not varisnull(datos.TCComercialGasto.fieldbyname('Codigo').value) then
      begin
        formmenuprincipal.accion := 'modificar';
        datos.tcomercialgasto.Active := true;
        datos.tcomercialgasto.locate ('Codigo',
            datos.TCComercialGasto.fieldbyname('Codigo').value,[]);
        datos.tcomercialgasto.edit;
        application.createform(tformcomercialgastog, formcomercialgastog);
        formcomercialgastog.ShowModal;
        ActRefrescarExecute(nil);        
      end
      else
        fp.msError ('Atencin, el ' + ventana + ' actual no tiene cdigo, ' +
            'elimnelo antes de continuar.','Error...');
    end;
  end;
end;

procedure tformcomercialgasto.TablaDblClick(Sender: TObject);
begin
  ActModificarExecute(nil);
end;

procedure tformcomercialgasto.ActRefrescarExecute(Sender: TObject);
begin
  ordenar(campoOrdenado, segCampo);
end;

procedure tformcomercialgasto.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure tformcomercialgasto.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure tformcomercialgasto.ActImprimirExecute(Sender: TObject);
begin
  if datos.TCComercialGasto.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario ('localizar', false) then
    begin
      application.createform(tformImprimir, formImprimir);
      formimprimir.Tag := 90;
      formImprimir.showmodal;
    end;
  end;
end;

procedure tformcomercialgasto.ActBuscarExecute(Sender: TObject);
begin
  if datos.TCComercialGasto.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if  fp.ComprobarUsuario ('localizar', false) then
    begin
      application.createform(tformLocalizar, formLocalizar);
      FormLocalizar.Tag := 90;
      formLocalizar.showmodal;
    end;
  end;
end;

procedure tformcomercialgasto.ActZoomExecute(Sender: TObject);
begin
  if datos.TCComercialGasto.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario('zoom', false) then
    begin
      formmenuprincipal.accion := 'zoom';
      formmenuprincipal.codigo := datos.TCComercialGasto.fieldbyname('Codigo').value;
      application.createform(tformcomercialgastog, formcomercialgastog);
      formcomercialgastog.ShowModal;
    end;
  end;
end;

procedure tformcomercialgasto.TablaTitleClick(Column: TColumn);
begin
  campoOrdenado := column.fieldname;
  nombreCampoOrdenado := Column.Title.Caption;
  caption := ventanas + ' (ordenado por ' + Column.Title.Caption + ')';
  ordenar (campoOrdenado, segCampo);
end;

procedure tformcomercialgasto.ActPtsExecute(Sender: TObject);
begin
  if ActEuros.Checked then
    MostrarEuros (false, 'Importe','','','',4,0,0,0)
  else
    MostrarEuros (true, 'ImporteE','','','',4,0,0,0);
end;

procedure tformcomercialgasto.BEuroClick(Sender: TObject);
begin
  if ActEuros.Checked then
    MostrarEuros (false, 'Importe','','','',4,0,0,0)
  else
    MostrarEuros (true, 'ImporteE','','','',4,0,0,0);
end;

procedure tformcomercialgasto.ActEurosExecute(Sender: TObject);
begin
  if ActEuros.Checked then
    MostrarEuros (false, 'Importe','','','',4,0,0,0)
  else
    MostrarEuros (true, 'ImporteE','','','',4,0,0,0);
end;

end.
