unit UnidadConfiguracion;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, inifiles,Tabnotbk, ToolWin, ExtCtrls,
  ActnList, Menus, DBCtrls, Db, DBTables, Printers, REGISTRY;

type
  TFormConfiguracion = class(TForm)
    Tab: TPageControl;
    TabDatos: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    GroupBox1: TGroupBox;
    OpMostrarProgreso: TCheckBox;
    OpFlat: TCheckBox;
    OpMostrarBB: TCheckBox;
    OpMostrarBE: TCheckBox;
    OpMostrarBBVentanas: TCheckBox;
    GroupBox5: TGroupBox;
    OpVentanasTamano: TCheckBox;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton2: TToolButton;
    ActionList1: TActionList;
    ActCerrar: TAction;
    ActGuardarConfiguracion: TAction;
    PopupMenu1: TPopupMenu;
    ActGuardarConfiguracion1: TMenuItem;
    N1: TMenuItem;
    Cerrar1: TMenuItem;
    TabSheet2: TTabSheet;
    BConfigurarImpresora: TSpeedButton;
    ConfigurarImpresora: TPrinterSetupDialog;
    ListaImpresoras: TListBox;
    Label9: TLabel;
    CImpresoraActual: TEdit;
    Label10: TLabel;
    BitBtn2: TBitBtn;
    GroupBox11: TGroupBox;
    OpEjecucionUnaVez: TCheckBox;
    OpEjecucionSiempre: TCheckBox;
    OPPrimero: TCheckBox;
    GroupBox3: TGroupBox;
    OpIPts: TRadioButton;
    OpIEuros: TRadioButton;
    GroupBox4: TGroupBox;
    TxtPIVA: TEdit;
    TxtPRetencion: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    OpGuardarVentanas: TCheckBox;
    GroupBox6: TGroupBox;
    OpMIPts: TRadioButton;
    OpMIE: TRadioButton;
    BCancelar: TBitBtn;
    Panel1: TPanel;
    BAceptar: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BConfigurarImpresoraClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ListaImpresorasDblClick(Sender: TObject);
    procedure TxtPIVAExit(Sender: TObject);
    procedure TxtPRetencionExit(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActCerrarExecute(Sender: TObject);
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure ActGuardarConfiguracionExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormConfiguracion: TFormConfiguracion;

implementation

uses UnidadMenuPrincipal, UnidadDatos;

{$R *.DFM}
var
  fp : tformmenuprincipal;

procedure TFormConfiguracion.FormShow(Sender: TObject);
begin
  try
    // Pasar la lista de impresoras a la lista
    ListaImpresoras.Items := Printer.Printers;
    // Mostrar la impresora actual
    CImpresoraActual.Text := Printer.Printers[Printer.PrinterIndex];
  except
  end;
  bb.flat := formmenuprincipal.vtflat;
  opmostrarprogreso.checked := formmenuprincipal.vtprogreso;
  opmostrarbb.checked := formmenuprincipal.vtmostrarbb;
  opmostrarbe.checked := formmenuprincipal.vtmostrarbe;
  opflat.checked := formmenuprincipal.vtflat;
  opventanastamano.checked := formmenuprincipal.vtestadocarga;
  opmostrarbbventanas.checked := formmenuprincipal.vtmostrarbbventanas;
  opejecucionsiempre.Checked :=
      formmenuprincipal.leBoolINI ('Aplicacion', cIniciarSiempre, false);
  OpIEuros.Checked :=
      formmenuprincipal.leBoolINI ('Aplicacion', cIntroducirEuros, false);
  OpIPts.Checked := not opieuros.Checked;
  TxtPIVA.text :=
      floattostr(formmenuprincipal.leFloatINI ('Aplicacion', cPorcentajeIVA, 7));
  TxtPRetencion.text :=
      floattostr(formmenuprincipal.leFloatINI ('Aplicacion', cPorcentajeRetencion, 2));
  OPPrimero.Checked :=
      formmenuprincipal.leBoolINI ('Aplicacion', cIniciarPrimero, false);
  OpEjecucionUnaVez.Checked :=
      formmenuprincipal.leBoolINI ('Aplicacion', cIniciar1Vez, false);
  OpGuardarVentanas.Checked :=
      formmenuprincipal.leBoolINI ('Aplicacion', cGuardarVentanas, false);
  OpMIE.Checked :=
      formmenuprincipal.leBoolINI ('Aplicacion', cMostrarEuros, false);
  OpMIPts.Checked := not (opmie.Checked);
end;

procedure TFormConfiguracion.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  screen.cursor := crdefault;
  action := cafree;
end;

procedure TFormConfiguracion.BConfigurarImpresoraClick(Sender: TObject);
begin
  ConfigurarImpresora.Execute;
  // Mostrar la impresora seleccionada
  CImpresoraactual.Text := Printer.Printers[Printer.PrinterIndex];
end;

procedure TFormConfiguracion.BitBtn2Click(Sender: TObject);
begin
  Printer.PrinterIndex := -1; // Elegir la impresora por defecto
  CImpresoraActual.Text := Printer.Printers[Printer.PrinterIndex];
end;

procedure TFormConfiguracion.ListaImpresorasDblClick(Sender: TObject);
begin
  // Hacer activa la impresora seleccionada
  Printer.PrinterIndex := ListaImpresoras.ItemIndex;
  CImpresoraActual.Text := Printer.Printers[Printer.PrinterIndex];
end;

procedure TFormConfiguracion.TxtPIVAExit(Sender: TObject);
begin
  try
    StrToFloat (TxtPIVA.text);
  except
    fp.msError ('Debe introducir un nmero vlido.', 'Error...');
    TxtPIVA.SelectAll;
    TxtPIVA.SetFocus;
  end;
end;

procedure TFormConfiguracion.TxtPRetencionExit(Sender: TObject);
begin
  try
    StrToFloat (TxtPRetencion.text);
  except
    fp.msError ('Debe introducir un nmero vlido.', 'Error...');
    TxtPRetencion.SelectAll;
    TxtPRetencion.SetFocus;
  end;
end;

procedure TFormConfiguracion.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TFormConfiguracion.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TFormConfiguracion.BCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TFormConfiguracion.BAceptarClick(Sender: TObject);
begin
  ActGuardarConfiguracionExecute (nil);
end;

procedure TFormConfiguracion.ActGuardarConfiguracionExecute(
  Sender: TObject);
var
  Reg: TRegistry;
begin
  formmenuprincipal.vtmostrarbe := opmostrarbe.Checked;
  formmenuprincipal.vtmostrarbbventanas := opmostrarbbventanas.Checked;
  formmenuprincipal.vtprogreso := opmostrarprogreso.Checked;
  formmenuprincipal.vtestadocarga := opventanastamano.Checked;
  formmenuprincipal.vtmostrarbb := opmostrarbb.Checked;
  formmenuprincipal.vtflat := opflat.Checked;
  //EJECUTAR UNA SLA VEZ AL CARGAR WINDOWS
  if opejecucionunavez.Checked then
  begin
    Reg := TRegistry.Create;
    try
      Reg.RootKey := HKEY_LOCAL_MACHINE;
      if Reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce', True)then
        Reg.WriteString(application.ExeName,'"' + ParamStr(0) + '"');
    finally
      Reg.CloseKey;
      Reg.Free;
      inherited;
    end;
  end
  else  //sino eliminar
  begin
    Reg := TRegistry.Create;
    try
      Reg.RootKey := HKEY_LOCAL_MACHINE;
      if Reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce', True) then
        reg.DeleteValue(application.exename);
    finally
      Reg.CloseKey;
      Reg.Free;
      inherited;
    end;
  end;


  //EJECUTAR AL CARGAR WINDOWS SIEMPRE
  if opejecucionsiempre.Checked then
  begin
    Reg := TRegistry.Create;
    try
      Reg.RootKey := HKEY_LOCAL_MACHINE;
      if Reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Run', True) then
        Reg.WriteString(application.ExeName,'"' + ParamStr(0) + '"');
    finally
      Reg.CloseKey;
      Reg.Free;
      inherited;
    end;
  end
  else  //sino eliminar
  begin
    Reg := TRegistry.Create;
    try
      Reg.RootKey := HKEY_LOCAL_MACHINE;
      if Reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Run', True) then
        reg.DeleteValue(application.exename);
    finally
      Reg.CloseKey;
      Reg.Free;
      inherited;
    end;
  end;

  //EJECUTAR primero
  if opprimero.Checked then
  begin
    Reg := TRegistry.Create;
    try
      Reg.RootKey := HKEY_LOCAL_MACHINE;
      if Reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\RunServices', True) then
        Reg.WriteString(application.ExeName,'"' + ParamStr(0) + '"');
    finally
      Reg.CloseKey;
      Reg.Free;
      inherited;
    end;
  end
  else  //sino eliminar
  begin
    Reg := TRegistry.Create;
    try
      Reg.RootKey := HKEY_LOCAL_MACHINE;
      if Reg.OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\RunServices', True) then
        reg.DeleteValue(application.exename);
    finally
      Reg.CloseKey;
      Reg.Free;
      inherited;
    end;
  end;

  with tinifile.create (changefileext(paramstr(0),'.INI')) do
  try
    writebool ('Aplicacion', cmBE,  OpMostrarBE.Checked);
    writebool ('Aplicacion', cmbbv, OpMostrarBBVentanas.Checked);
    writebool ('Aplicacion', cmProgreso, OpMostrarProgreso.Checked);
    writebool ('Aplicacion', cmMaximizar, opventanastamano.Checked);
    writebool ('Aplicacion', cmBBP, opmostrarbb.Checked);
    writebool ('Aplicacion', cmFlat, OpFlat.Checked);
    WriteBool('Aplicacion', cIniciarSiempre, OpEjecucionSiempre.Checked);
    WriteBool('Aplicacion', cIntroducirEuros, OpIEuros.Checked);
    try
      WriteFloat('Aplicacion', cPorcentajeIVA, strtofloat(TxtPIVA.text));
    except
      fp.msError ('Debe introducir un nmero vlido.', 'Error...');
      tabdatos.show;
      TxtPIVA.SelectAll;
      TxtPIVA.SetFocus;
      exit;
    end;
    try
      WriteFloat('Aplicacion', cPorcentajeRetencion, strtofloat(TxtPRetencion.text));
    except
      fp.msError ('Debe introducir un nmero vlido.', 'Error...');
      tabdatos.show;
      TxtPRetencion.SelectAll;
      TxtPRetencion.SetFocus;
      exit;
    end;
    WriteBool('Aplicacion', cIniciar1Vez, opejecucionunavez.Checked);
    WriteBool('Aplicacion', cIniciarPrimero, OPPrimero.Checked);
    WriteBool('Aplicacion', cGuardarVentanas, OpGuardarVentanas.Checked);
    WriteBool('Aplicacion', cMostrarEuros, OpMIE.Checked);
  finally
    free;
  end;
  close;
end;

end.
