unit UnidadCopiaSeguridad;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DirOutln, FileCtrl, Buttons, Menus, ComCtrls,
  Tabnotbk, ExtCtrls,inifiles, Db, DBTables, Qrctrls, QuickRpt, shlobj, activex,
  ToolWin, ActnList,variants;

type
  TFormCopiaSeguridad = class(TForm)
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    Eliminarcarpeta1: TMenuItem;
    N2: TMenuItem;
    Hacercopiadeseguridad1: TMenuItem;
    Tab: TPageControl;
    TabCopia: TTabSheet;
    TabRestaurar: TTabSheet;
    GroupBox1: TGroupBox;
    BCopia: TBitBtn;
    GroupBox2: TGroupBox;
    Unidad2: TDriveComboBox;
    StaticText3: TStaticText;
    Carpeta2: TDirectoryListBox;
    Ficheros2: TFileListBox;
    NFicheros2: TStaticText;
    BRestaurar: TBitBtn;
    DEmpresas : TDataSource;
    TEmpresas: TTable;
    L: TStaticText;
    Label1: TLabel;
    Panel2: TPanel;
    Label2: TLabel;
    L2: TStaticText;
    Panel3: TPanel;
    Label3: TLabel;
    LFecha: TStaticText;
    LHora: TStaticText;
    Label4: TLabel;
    LUsuario: TStaticText;
    Label5: TLabel;
    LRuta: TStaticText;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    LLibre: TLabel;
    LTamano: TLabel;
    Label9: TLabel;
    LOcupado: TLabel;
    Carpeta: TDirectoryListBox;
    Unidad: TDriveComboBox;
    StaticText1: TStaticText;
    Panel6: TPanel;
    StaticText4: TStaticText;
    LDestino: TStaticText;
    StaticText5: TStaticText;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    ToolButton2: TToolButton;
    ActionList1: TActionList;
    ActCerrar: TAction;
    ActConectar: TAction;
    ActBuscarCarpeta: TAction;
    PopupMenu2: TPopupMenu;
    ToolButton4: TToolButton;
    Buscarcarpeta1: TMenuItem;
    Conectaraunaunidaddered1: TMenuItem;
    N3: TMenuItem;
    Cerrar1: TMenuItem;
    ActHacerCopia: TAction;
    Realizarcopia1: TMenuItem;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ActRestaurar: TAction;
    ToolButton7: TToolButton;
    PopupMenu3: TPopupMenu;
    Restaurarcopia1: TMenuItem;
    N4: TMenuItem;
    Cerrar2: TMenuItem;
    procedure BCerrarClick(Sender: TObject);
    procedure UnidadChange(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure Eliminarcarpeta1Click(Sender: TObject);
    procedure BCopiaClick(Sender: TObject);
    procedure CarpetaChange(Sender: TObject);
    procedure FicherosChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BRestaurarClick(Sender: TObject);
    procedure Carpeta2Change(Sender: TObject);
    procedure Unidad2Change(Sender: TObject);
    procedure Ficheros2Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FicherosChange2(Sender: TObject);
    procedure ActConectarExecute(Sender: TObject);
    procedure ActBuscarCarpetaExecute(Sender: TObject);

    procedure guardarDatosCopia (rut : String);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormCopiaSeguridad: TFormCopiaSeguridad;

implementation

uses UnidadMenuPrincipal, UnidadDatos, UnidadI;

{$R *.DFM}
var

  fp : tformmenuprincipal;

procedure TFormCopiaSeguridad.BCerrarClick(Sender: TObject);
begin
  close;
end;

function formatearTamano (tamano : int64) : string;
begin
  try
    if (tamano < 1047527424)  and (tamano > 1048576) then  // >999 MB y  <1 MB
    begin
      result := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
         tamano / 1048576) + ' MB';
      exit;
    end;
    if (tamano > 1047527424) then  // >999 MB
    begin
      result := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
         tamano / 1073741824) + ' GB';
      exit;
    end;
    if (tamano < 1048576) then // 1< MB
    begin
      result := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
         tamano / 1024) + ' KB';
      exit;
    end;
  except
    result := '0';
    raise;
  end;
end;


procedure TFormCopiaSeguridad.UnidadChange(Sender: TObject);
var
  unidadseleccionada: integer;
begin
  carpeta.drive := unidad.Drive;
  carpeta.Update;
  try
    UnidadSeleccionada := Ord(UpCase(Unidad.Drive)) - Ord('A') + 1;
    ltamano.caption := formateartamano(DiskSize(UnidadSeleccionada));
    llibre.caption := formateartamano(DiskFree(UnidadSeleccionada));
    locupado.caption := formateartamano(DiskSize(UnidadSeleccionada) -
         DiskFree(UnidadSeleccionada));
  except
    //silenciosa
  end;
end;

procedure TFormCopiaSeguridad.N1Click(Sender: TObject);
var
  Nombre: string;
  Fecha: TDateTime;
  Ano, Mes, Dia: Word;
  ano2, mes2, dia2 : word;
begin
  fecha := date;
  DecodeDate(fecha, ano, mes, dia);
  decodedate (FormMenuPrincipal.VTFinEmpresa, ano2, mes2, dia2);
  nombre := inttostr(ano2) +
      '_' + inttostr(dia) + '-' + inttostr(mes) + '-' + inttostr(ano);
  if inputquery('Nueva carpeta...','Introduzca el nombre de la carpeta.',Nombre) then
  begin
    if not createdir(nombre) then
      fp.mserror ('No se ha podido aadir la nueva carpeta. Compruebe que no exista otra con el mismo nombre y que tenga permisos sobre la unidad.',
          'Crear nueva carpeta...')
    else
      carpeta.Directory := Carpeta.Directory + '\' + nombre;
    carpeta.Update;
  end;
end;

procedure TFormCopiaSeguridad.Eliminarcarpeta1Click(Sender: TObject);
var
  directorio: string;
begin
  directorio:=carpeta.getitempath(carpeta.itemindex);
  carpeta.directory:=carpeta.getitempath(carpeta.itemindex-1);
  try
    rmdir (directorio);
  except
    raise;
  end;
  carpeta.Update;
//  ficheros.update;
end;


procedure tformcopiaseguridad.guardarDatosCopia (rut : String);
begin
  dempresas.DataSet.open;
  with tinifile.create (rut) do
  try
    writestring('Empresa','Nombre',formmenuprincipal.vtnombreempresa);
    writeinteger('Empresa','Ruta',formmenuprincipal.vtIDempresa);
    writedate('Copia Seguridad','Fecha',date);
    writetime('Copia Seguridad','Hora',time);
    writestring('Copia Seguridad','Usuario',formmenuprincipal.VTTipoUsuario);
    if tempresas.locate('Codigo',formmenuprincipal.VTIDEmpresa,[]) then
    begin
      writeinteger('Empresa','ID',dempresas.dataset.fieldbyname('Codigo').value);
      if not varisnull(dempresas.dataset.fieldbyname('FechaAlta').value) then
        writedate('Empresa','FechaAlta',dempresas.dataset.fieldbyname('FechaAlta').value);
      if not varisnull(dempresas.dataset.fieldbyname('FechaBaja').value) then
        writedate('Empresa','FechaBaja',dempresas.dataset.fieldbyname('FechaBaja').value);
      if not varisnull(dempresas.dataset.fieldbyname('Moneda').value) then
        writestring('Empresa','Moneda',dempresas.dataset.fieldbyname('Moneda').value);
      if not varisnull(dempresas.dataset.fieldbyname('Cambio').value) then
        writefloat('Empresa','Cambio',dempresas.dataset.fieldbyname('Cambio').value);
      if not varisnull(dempresas.dataset.fieldbyname('Nota').value) then
        writestring('Empresa','Nota',dempresas.dataset.fieldbyname('Nota').value);
      writestring('Empresa','Usuario','');
      if not varisnull(dempresas.dataset.fieldbyname('CIF').value) then
        writestring('Empresa','CIF',dempresas.dataset.fieldbyname('CIF').value);
      if not varisnull(dempresas.dataset.fieldbyname('Domicilio').value) then
        writestring('Empresa','Domicilio',dempresas.dataset.fieldbyname('Domicilio').value);
      if not varisnull(dempresas.dataset.fieldbyname('Poblacion').value) then
        writestring('Empresa','Poblacion',dempresas.dataset.fieldbyname('Poblacion').value);
      if not varisnull(dempresas.dataset.fieldbyname('Provincia').value) then
        writestring('Empresa','Provincia',dempresas.dataset.fieldbyname('Provincia').value);
      if not varisnull(dempresas.dataset.fieldbyname('CP').value) then
        writefloat('Empresa','CP',dempresas.dataset.fieldbyname('CP').value);
      if not varisnull(dempresas.dataset.fieldbyname('Telefono').value) then
        writestring('Empresa','Telefono',dempresas.dataset.fieldbyname('Telefono').value);
      if not varisnull(dempresas.dataset.fieldbyname('Fax').value) then
        writestring('Empresa','Fax',dempresas.dataset.fieldbyname('Fax').value);
      if not varisnull(dempresas.dataset.fieldbyname('EMail').value) then
        writestring('Empresa','EMail',dempresas.dataset.fieldbyname('EMail').value);
      if not varisnull(dempresas.dataset.fieldbyname('RutaLogotipo').value) then
        writestring('Empresa','Rutalogotipo',dempresas.dataset.fieldbyname('RutaLogotipo').value);
      if not varisnull(dempresas.dataset.fieldbyname('AjustarTamano').value) then
        writebool('Empresa','AjustarTamano',dempresas.dataset.fieldbyname('AjustarTamano').value);
      writebool('Empresa','Ficheros',True);
    end;
  finally
    free;
  end;
end;
procedure TFormCopiaSeguridad.BCopiaClick(Sender: TObject);
var
  rutacopia: string;
  rutaprograma: string;
  rutaficheroprograma: string;
  nombre2: tsearchrec;
  Atributos: Integer;
  rutacopiafichero: string;
begin
  tabcopia.show;
  if ldestino.Caption = '' then
  begin
    fp.msInfo ('Seleccione la unidad y carpeta de destino de la copia de seguridad.',
        'Hacer copia de seguridad...');
    Unidad.SetFocus;
    exit;
  end;
  atributos:=faAnyFile;
//  ficheros.Clear;
  rutacopia := ldestino.caption + '\';

  if (FormMenuPrincipal.vtservidor = 1) then
    rutaprograma := ExtractFilePath(Application.ExeName) + 'Emp' +
        inttostr(FormMenuPrincipal.VTIDEmpresa) + '\'
  else
    rutaprograma := FormMenuPrincipal.vtrutaservidor + 'Emp' +
        inttostr(FormMenuPrincipal.VTIDEmpresa) + '\';

  rutacopia := uppercase(rutacopia);
  if (rutacopia=uppercase(Rutaprograma)) or (rutacopia=uppercase(extractfilepath(application.exename))) or
      (rutacopia=uppercase(extractfilepath(application.exename) + 'Tablas\')) or
      (rutacopia=uppercase('C:\')) or (rutacopia=uppercase('C:\\')) or
      (rutacopia=uppercase('C:\WINDOWS\')) then
  begin
    fp.msatencion ('No se puede realizar la copia de seguridad en la ruta ' +
        'especificada: ' + #13 + #13 + rutacopia + #13 + #13 +  #13+ #13 +
      'Seleccione otra carpeta/unidad donde hacer la copia de seguridad.',
      'Copia de seguridad...');
    exit;
  end;
  if not fp.msok ('Se va a realizar una copia de seguridad de la empresa: ' +
      #13 +#13+ formmenuprincipal.vtnombreempresa +' [Ruta: ' +
          rutaprograma + ']'+ #13 + #13 + 'En la ruta:' +
      #13 + #13+rutacopia + #13 + #13+#13 +
      'ATENCIN: recuerde que ser eliminado el contenido de la carpeta ' +
      rutacopia + '.','Copia de seguridad...') then
    exit;
  if formmenuprincipal.VTProgreso then
  begin
    formi.Animacion.CommonAVI := aviCopyFiles;
    formi.Animacion.active := true;
    formi.L.caption := 'Realizando copia de seguridad, espere por favor...';
    formi.B.visible := false;
    formi.show;
    formi.refresh;
  end;
  guardarDatosCopia(rutaprograma + 'CS.ini');
  Application.ProcessMessages;
  datos.db.CloseDataSets;
  datos.db.close;
  if FindFirst(rutaprograma + '*.*', Atributos, Nombre2) = 0 then
  begin
    rutacopiafichero := rutacopia + nombre2.name;
    rutaficheroprograma := rutaprograma + nombre2.name;
    if formmenuprincipal.VTProgreso then
    begin
      formi.L.caption := 'Copiando fichero ' + nombre2.name;
      formi.l.refresh;
      formi.Refresh;
    end;
    try
      copyfile(pchar(rutaficheroprograma), pchar(rutacopiafichero), false);
    except
      if formmenuprincipal.VTProgreso then
        formi.close;
//      ficheros.Update;
//      ficheros.Refresh;
      raise;
    end;
    while findnext(nombre2) = 0 do
    begin
      rutacopiafichero := rutacopia + nombre2.name;
      rutaficheroprograma := rutaprograma + nombre2.name;
      if formmenuprincipal.VTProgreso then
      begin
        formi.L.caption := 'Copiando fichero ' + nombre2.name;
        formi.l.refresh;
        formi.Refresh;
      end;
      try
        copyfile(pchar(rutaficheroprograma), pchar(rutacopiafichero), false);
      except
        if formmenuprincipal.VTProgreso then
          formi.close;
//        ficheros.Update;
//        ficheros.Refresh;
        raise;
      end;
    end;
    FindClose(nombre2);
  end;
//  ficheros.Update;
//  ficheros.Refresh;
  guardarDatosCopia(rutacopia + 'CS.ini');
  if formmenuprincipal.VTProgreso then
    formi.close;
  fp.msinfo ('La copia de seguridad se ha realizado con xito.',
      'Copia de seguridad...');
  close;
end;

procedure TFormCopiaSeguridad.CarpetaChange(Sender: TObject);
begin
  try
    ldestino.caption := carpeta.directory;
//    ficheros.drive:=unidad.Drive;
//    ficheros.Directory:=carpeta.Directory;
//    ficheros.Update;
  except
    //silenciosa
    ldestino.caption := '';
  end;
end;

procedure TFormCopiaSeguridad.FicherosChange(Sender: TObject);
begin
//  nficheros.caption:='N de ficheros: ' + inttostr(ficheros.items.Count);
//  nficheros.Refresh;
end;

procedure TFormCopiaSeguridad.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  screen.cursor:=crdefault;
  action := caFree;
end;

procedure TFormCopiaSeguridad.BRestaurarClick(Sender: TObject);
var
  rutadesdedondecopiar: string;
  rutaempresaendondecopiar: string;
  nombre2: tsearchrec;
  Atributos,IDEmpresa: Integer;
  vempresa,vusuario,vruta: string;
  vhora:ttime;
  vfecha:tdate;
begin
  tabrestaurar.show;
  if l2.Caption = '' then
  begin
    fp.msInfo ('Seleccione la unidad y carpeta donde se encuentre la empresa a restaurar.',
        'Restaurar copia de seguridad...');
    Unidad2.SetFocus;
    exit;
  end;
  atributos:=faAnyFile;
  datos.db.CloseDataSets;
  datos.db.close;
  rutadesdedondecopiar:=carpeta2.getitempath(carpeta2.itemindex) + '\';
  with tinifile.create (rutadesdedondecopiar + 'CS.ini') do
  try
    vempresa:=readstring('Empresa','Nombre','');
    vfecha:=readdate('Copia Seguridad','Fecha',date);
    vhora:=readtime('Copia Seguridad','Hora',time);
    vusuario:=readstring('Aplicacin','Usuario','');
    idempresa:=readinteger('Empresa','ID',0);

    if FormMenuPrincipal.vtservidor = 1 then
      vruta := ExtractFilePath(Application.ExeName) + 'Emp' +
         inttostr(idEmpresa)
    else
      vruta := formmenuprincipal.vtrutaservidor + 'Emp' +
         inttostr(idEmpresa);

    tempresas.open;
    if not tempresas.locate('Codigo',IDEmpresa,[]) then
    begin
      dempresas.dataset.insert;
      dempresas.dataset.fieldbyname('NombreEmpresa').value:=vempresa;
      dempresas.dataset.fieldbyname('Codigo').value:=idempresa;
//      dempresas.dataset.fieldbyname('Ruta').value:=vruta;
      dempresas.dataset.fieldbyname('Ficheros').value:=True;
      dempresas.dataset.fieldbyname('FechaAlta').value:=readdate('Empresa','FechaAlta',date);
      dempresas.dataset.fieldbyname('FechaBaja').value:=readdate('Empresa','FechaBaja',date);
      dempresas.dataset.fieldbyname('FechaAlta').value:=readdate('Empresa','FechaAlta',date);
      dempresas.dataset.fieldbyname('Moneda').value:=readstring('Empresa','Moneda','pta');
      dempresas.dataset.fieldbyname('Cambio').value:=readfloat('Empresa','Cambio',1);
      dempresas.dataset.fieldbyname('Nota').value:=readstring('Empresa','Nota','');
//      dempresas.dataset.fieldbyname('Usuario').value:=readstring('Empresa','Usuario','');
      dempresas.dataset.fieldbyname('CIF').value:=readstring('Empresa','CIF','');
      dempresas.dataset.fieldbyname('Domicilio').value:=readstring('Empresa','Domicilio','');
      dempresas.dataset.fieldbyname('Poblacion').value:=readstring('Empresa','Poblacion','');
      dempresas.dataset.fieldbyname('Provincia').value:=readstring('Empresa','Provincia','');
      dempresas.dataset.fieldbyname('CP').value:=readfloat('Empresa','CP',0);
      dempresas.dataset.fieldbyname('Telefono').value:=readstring('Empresa','Telefono','');
      dempresas.dataset.fieldbyname('Fax').value:=readstring('Empresa','Fax','');
      dempresas.dataset.fieldbyname('EMail').value:=readstring('Empresa','EMail','');
      dempresas.dataset.fieldbyname('RutaLogotipo').value:=readstring('Empresa','Rutalogotipo','');
      dempresas.dataset.fieldbyname('AjustarTamano').value:=readbool('Empresa','AjustarTamano',False);
      dempresas.dataset.post;
    end;
  finally
    free;
  end;
  if (vempresa='') and (vruta='') and (vusuario='') then
  begin
    fp.msinfo ('No se ha encontrado ninguna copia de seguridad en la ' +
        'ruta especificada. Seleccione otra ruta.', 'Restaurar copia...');
    exit;
  end;
  if not fp.msok ('Se va a restaurar una copia de seguridad de la empresa: ' +
      #13 +#13+ vempresa + #13 + #13 + 'En la ruta:' +
      #13 + #13+vruta + #13 + #13 + 'Fecha realizacin: ' +
      datetostr(vfecha) + #13 + '  Hora realizacin: ' + timetostr(vhora) +
      #13 + #13 + #13 + 'ATENCIN: recuerde que sern eliminados los datos ' +
      'actuales de esta empresa y reemplazados por la copia de seguridad.',
      'Restaurar copia de seguridad...') then
    exit;
  Rutaempresaendondecopiar := vruta + '\';
  if not directoryexists(vruta) then
    createdir (vruta)
  else
    if not fp.msok ('ATENCIN: se van a eliminar los datos de la carpeta:'+
        #13 + #13 + vruta + #13 + #13 + #13 + ' Contine slo si est seguro.',
        'Restaurar copia de seguridad...') then
    begin
      screen.cursor := crdefault;
      exit;
    end;
  if formmenuprincipal.VTProgreso then
  begin
    formi.Animacion.CommonAVI := aviCopyFiles;
    formi.Animacion.active := true;
    formi.L.caption := 'Restaurando copia de seguridad, espere por favor...';
    formi.B.visible := false;
    formi.show;
    formi.refresh;
  end;
  carpeta2.Directory:=rutaempresaendondecopiar;
  carpeta2.refresh;
  if FindFirst(rutadesdedondecopiar+'*.*', Atributos, Nombre2) = 0 then
  begin
    if formmenuprincipal.VTProgreso then
    begin
      formi.L.caption:='Copiando fichero ' + nombre2.name;
      formi.l.refresh;
    end;
    try
      copyfile(pchar(rutadesdedondecopiar + nombre2.name),pchar(rutaempresaendondecopiar + nombre2.name),false);
    except
      if formmenuprincipal.VTProgreso then
        formi.close;
      raise;
    end;
    while findnext(nombre2)=0 do
    begin
      if formmenuprincipal.VTProgreso then
      begin
        formi.L.caption:='Copiando fichero ' + nombre2.name;
        formi.l.refresh;
      end;
      try
        copyfile(pchar(rutadesdedondecopiar + nombre2.name),pchar(rutaempresaendondecopiar + nombre2.name),false);
      except
        if formmenuprincipal.VTProgreso then
          formi.close;
        raise;
      end;
    end;
    FindClose(nombre2);
  end;
  if formmenuprincipal.VTProgreso then
    formi.close;
  fp.msinfo ('La copia de seguridad se ha restaurado con xito.',
      'Copia de seguridad...');
  close;
end;

procedure TFormCopiaSeguridad.Carpeta2Change(Sender: TObject);
var
  nombreempresa,rutaempresa,usuario:string;
  codigoempresa:integer;
  fecha:tdate;
  hora:ttime;
begin
  ficheros2.drive:=unidad2.Drive;
  ficheros2.Directory:=carpeta2.Directory;
  ficheros2.Update;
  l2.caption:='';
  lruta.caption:='';
  lfecha.caption:='';
  lhora.caption:='';
  lusuario.caption:='';
  if fileexists(carpeta2.directory + '\CS.ini') then
  begin
    with tinifile.create (carpeta2.Directory + '\CS.ini') do
    try
      nombreempresa:=readstring('Empresa','Nombre','');
      codigoempresa:=readinteger('Empresa','ID',0);
      if FormMenuPrincipal.vtservidor = 1 then
        rutaempresa := ExtractFilePath(Application.ExeName) + 'Emp' +
           inttostr(codigoEmpresa)
      else
        rutaempresa := formmenuprincipal.vtrutaservidor + 'Emp' +
           inttostr(codigoEmpresa);
//      rutaempresa:=readstring('Empresa','Ruta','');
      fecha:=readdate('Copia Seguridad','Fecha',date);
      hora:=readtime('Copia Seguridad','Hora',time);
      usuario:=readstring('Copia Seguridad','Usuario','');
    finally
      free;
    end;
    if ((nombreempresa='') and (codigoempresa=0)) or (rutaempresa='') then
    begin
    end
    else
    begin
      l2.caption:=inttostr(codigoempresa) + ' - ' + nombreempresa;
      lruta.caption:=rutaempresa;
      lfecha.caption:=datetostr(fecha);
      lhora.caption:=timetostr(hora);
      lusuario.caption:=usuario;
    end;
  end;
  l2.refresh;
  lruta.refresh;
  lfecha.refresh;
  lhora.refresh;
  lusuario.refresh;
end;

procedure TFormCopiaSeguridad.Unidad2Change(Sender: TObject);
begin
  carpeta2.drive:=unidad2.Drive;
  carpeta2.Update;
end;

procedure TFormCopiaSeguridad.Ficheros2Change(Sender: TObject);
begin
  nficheros2.caption:='N de ficheros: ' + inttostr(ficheros2.items.Count);
  nficheros2.Refresh;
end;

procedure TFormCopiaSeguridad.FormShow(Sender: TObject);
begin
  TEmpresas.close;
  if FormMenuPrincipal.vtservidor = 1 then
    tempresas.DatabaseName := ExtractFilePath(application.exename)
  else
    tempresas.DatabaseName := formmenuprincipal.vtrutaservidor;
  try
    //NO TERMINADO -> MOSTRAR LA RUTA DEL REGEDIT CON FUNCIN
    carpeta.Directory := 'c:\mis documentos\';
  except
    //silenciosa
  end;
  if formmenuprincipal.tag = 70 then
  begin
    formmenuprincipal.tag := 0;
    tab.pages[1].show;
    fp.msinfo ('Seleccione la unidad y carpeta donde se encuentre la copia ' +
        'de seguridad a restaurar y pulse "Restaurar copia de seguridad".',
        'Restaurar copia de seguridad...');
  end;
  l.caption := inttostr(formmenuprincipal.vtidempresa) +
      ' - ' + formmenuprincipal.VTNombreEmpresa;
  l.refresh;
end;

procedure TFormCopiaSeguridad.FicherosChange2(Sender: TObject);
begin
//  nficheros.caption:='N de ficheros: ' + inttostr(ficheros.items.Count);
//  nficheros.Refresh;
end;


procedure TFormCopiaSeguridad.ActConectarExecute(Sender: TObject);
begin
  WNetConnectionDialog(Handle,RESOURCETYPE_DISK);
  unidad.Clear;
  Unidad.Update;
  unidad.refresh;
end;

procedure TFormCopiaSeguridad.ActBuscarCarpetaExecute(Sender: TObject);
var
  Inf: TBrowseInfo;
  Identificador: PItemIDList;
  Gestor: IMalloc;
  mCarpeta: Array[0..MAX_PATH] Of Char;
begin
  With Inf Do
  Begin // Inicializamos la estructura
    hwndOwner := Handle;
    pidlRoot := Nil;
    pszDisplayName := mCarpeta;
    lpszTitle := 'Seleccione la ruta de destino de la copia de seguridad.';
    ulFlags := BIF_BROWSEINCLUDEFILES;
    lpfn := Nil;
  End;
  // Abrir el cuadro de dilogo para seleccionar una carpeta
  Identificador := SHBrowseForFolder(Inf);
  // Si no se ha pulsado el botn Cancelar
  If Identificador <> Nil Then
  Begin // Obtenemos el camino
    SHGetPathFromIDList(Identificador, mCarpeta);
    // Liberamos el identificador
    SHGetMalloc(Gestor);
    Gestor.Free(Identificador);
    ldestino.caption := mcarpeta;
  end;
end;

end.
