unit UnidadEmpresas;

interface

uses
  Windows, inifiles,Messages, Classes, SysUtils, Graphics, Controls, StdCtrls, Forms,
  Dialogs, DBCtrls, DB, DBTables, Mask, ExtCtrls, ComCtrls, Buttons, Menus,
  Grids, DBGrids, ToolWin, Qrctrls, QuickRpt, ActnList, ExtDlgs, FileCtrl,bde,variants;

type
  TFormEmpresas = class(TForm)
    CB: TControlBar;
    LImpresion: TQuickRep;
    QRBand1: TQRBand;
    QRBand2: TQRBand;
    QRLabel7: TQRLabel;
    QRLabel8: TQRLabel;
    QRLabel4: TQRLabel;
    QRLabel6: TQRLabel;
    QRBand3: TQRBand;
    QRSysData2: TQRSysData;
    QRSysData4: TQRSysData;
    LEmpresa: TQRLabel;
    QRBand4: TQRBand;
    LTitulo: TQRSysData;
    QRLabel1: TQRLabel;
    QRLabel2: TQRLabel;
    QRLabel3: TQRLabel;
    QRLabel5: TQRLabel;
    QRLabel9: TQRLabel;
    QRLabel10: TQRLabel;
    QRLabel11: TQRLabel;
    QRLabel12: TQRLabel;
    QRBand5: TQRBand;
    QRDBText9: TQRDBText;
    QRDBText10: TQRDBText;
    QRDBText3: TQRDBText;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    QRDBText4: TQRDBText;
    QRDBText6: TQRDBText;
    QRDBText8: TQRDBText;
    QRDBText5: TQRDBText;
    QRDBText7: TQRDBText;
    QRDBText11: TQRDBText;
    QRDBText12: TQRDBText;
    ActionList1: TActionList;
    ActControlarSuprimir: TAction;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ActRefrescar: TAction;
    ActCerrar: TAction;
    ActImprimir: TAction;
    ActBuscar: TAction;
    PopupMenu1: TPopupMenu;
    Aadir1: TMenuItem;
    Modificar1: TMenuItem;
    Eliminar1: TMenuItem;
    Buscar1: TMenuItem;
    N1: TMenuItem;
    Refrescar1: TMenuItem;
    Imprimir1: TMenuItem;
    N2: TMenuItem;
    Cerrar1: TMenuItem;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton9: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton8: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ActSeleccionar: TAction;
    ActSeleccionar1: TMenuItem;
    N3: TMenuItem;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    Tabla: TDBGrid;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure TEmpresasPostError(DataSet: TDataSet; E: EDatabaseError;
      var Action: TDataAction);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActEliminarExecute(Sender: TObject);
    procedure ActModificarExecute(Sender: TObject);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActSeleccionarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActBuscarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActNuevoExecute(Sender: TObject);

    procedure ordenar (campo : string; campoFijo : string);
    procedure TablaTitleClick(Column: TColumn);
    procedure FormCreate(Sender: TObject);


  private
    campoOrdenado : String;  //nombre del campo ordenado
    nombreCampoOrdenado : String;  //nombre del label del campo ordenado
    { private declarations }
  public
    { public declarations }
  end;

var
  FormEmpresas: TFormEmpresas;
const
  ventana = 'Empresa'; //nombre de la ventana en singular
  ventanas = 'Empresas';  //nombre de la ventana en plural
  segCampo = 'Nombre';  //segundo campo de ordenacin para SQL

implementation

uses UnidadI, UnidadMenuPrincipal, UnidadDatos, UnidadLocalizar,
  UnidadGEmpresa, UnidadImprimir;



{$R *.DFM}
var
  fp : TFormMenuPrincipal;

procedure tFormEmpresas.ordenar (campo : string; campoFijo : string);
var
  lugar : string;
begin
  lugar := '';
  with datos.tcempresa do
  begin
    if Active then
    begin
      Refresh;
      if RecordCount > 0 then
        lugar := fieldbyname('Codigo').value;
    end;
    close;
    sql.clear;
    sql.add ('SELECT *');
    sql.add ('FROM ' + ventana);
    sql.add ('ORDER BY ' + campo + ',' + campoFijo);
    try
  //  ExecSQL;
      open;
    except
      raise;
    end;
    if lugar <> '' then
      locate ('Codigo',lugar,[]);
  end;
end;


procedure TFormEmpresas.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  i : integer;
begin
  //Guardar el ancho de las columnas y configuracin
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    WriteString('Tabla ' + ventanas, cCLugar, inttostr(datos.TCEmpresaCodigo.value));
    writestring('Tabla ' + ventanas, cCOrdenar, campoOrdenado);
    writestring('Tabla ' + ventanas, ccTituloOrdenar, nombreCampoOrdenado);
    for I := 0 to tabla.Columns.Count - 1 do
    begin
      with tabla.Columns.Items[I] do
        WriteInteger('Tabla ' + ventanas, FieldName, Width);
    end;
  finally
    Free;
  end;
  try
    datos.TCEmpresa.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TFormEmpresas.FormShow(Sender: TObject);
var
  I : Integer;
  lugar : string;
begin
  cb.visible := formmenuprincipal.vtmostrarbbventanas;
  bb.flat := formmenuprincipal.vtflat;

  //si hay que restablecer la ventana segn la ltima vez
  if FormMenuPrincipal.leBoolINI ('Aplicacion', cGuardarVentanas, false) then
  begin
    with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
    try
      lugar := readString('Tabla ' + ventanas, cclugar, '0');
      campoOrdenado := readstring('Tabla ' + ventanas, ccordenar, 'Codigo');
      nombreCampoOrdenado := readstring('Tabla ' + ventanas, ccTituloOrdenar, 'Cdigo');
      if campoOrdenado = '' then
        campoOrdenado := 'Codigo';
      if nombreCampoOrdenado = '' then
        nombreCampoOrdenado := 'Cdigo';
    finally
      Free;
    end;
    ordenar(campoOrdenado, segCampo);
    Datos.TCEmpresa.Locate ('Codigo', lugar, []);
  end
  else
  begin
    campoOrdenado := 'Codigo';
    ordenar(campoOrdenado, segCampo);
    nombreCampoOrdenado := 'Cdigo';
  end;

  //ancho de columnas
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    for I := 0 to tabla.Columns.Count - 1 do
      with tabla.Columns.Items[I] do
        Width := ReadInteger('Tabla ' + ventanas, FieldName, Width);
  finally
    Free;
  end;

  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas + ' (ordenado por ' + nombrecampoordenado + ')';
  screen.cursor := crdefault;
end;

function GetBDEError(E:EDatabaseError):integer;
var
  i:integer;
begin
  if E is EDBEngineError then
  with EDBEngineError(E) do
    for i:=0 to Errorcount-1 do
    begin
      Result:=Errors[i].errorcode;
      if result<>DBIERR_USERCONSTRERR then
        if result=DBIERR_CONSTRAINTFAILED then
          databaseerror(errors[i].message)
        else if errors[i].nativeerror=0 then
          exit;
    end;
  result:=1;
end;

procedure TFormEmpresas.TEmpresasPostError(DataSet: TDataSet;
  E: EDatabaseError; var Action: TDataAction);
begin
  case GetBDEError(e) of
     DBIERR_KEYVIOL:
       DatabaseError('El cdigo de la empresa ya existe.');
     DBIERR_REQDERR:
       DatabaseError('Faltan datos por introducir en la empresa actual (Cdigo, nombre, fecha inicio, fecha fin, usuario, moneda  cambio).');
  end;
end;

procedure TFormEmpresas.TablaKeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(13) then
    ActSeleccionarExecute (nil);
end;

procedure TFormEmpresas.ActEliminarExecute(Sender: TObject);
var
  nombre: TSearchRec;
  NombreEmpresa: string;
  codigo:integer;
  Atributos: Integer;
  rutacopia: string;
begin
  if datos.TCEmpresa.recordcount <= 0 then
    fp.msinfo ('No hay ' + ventanas + ' para eliminar.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario('altas/bajas', false) then
    begin
      if not varisnull(datos.TCEmpresaNombre.value) then
        nombreempresa := datos.TCEmpresaNombre.value
      else
        nombreempresa:='';
      if not varisnull(datos.TCEmpresaCodigo.value) then
        codigo := datos.TCEmpresaCodigo.value
      else
        codigo := -33333;
      if codigo = formmenuprincipal.VTIDEmpresa then
      begin
        if codigo = formmenuprincipal.VTIDEmpresa then
        begin
          fp.mserror ('No puede eliminar la empresa activa.',
              'Empresa activa...');
          exit;
        end;
      end;
      datos.TEmpresa.open;
      datos.tempresa.locate ('Codigo', codigo, []);
      datos.tempresa.edit;
      if formmenuprincipal.vtservidor = 1 then
        rutacopia := extractfilepath(application.ExeName) + 'Emp' +
            inttostr(codigo)
      else
        rutacopia :=  formmenuprincipal.vtrutaservidor + 'Emp' +
            inttostr(codigo);
      if DirectoryExists (rutacopia) then
      begin
        if not fp.mssi('Est seguro que desea ELIMINAR la empresa ' + #13 + #13 +
            ' -> ' + inttostr(codigo) + ' - ' + NombreEmpresa + #13 +
            ' -> Ruta: ' + rutacopia + #13 + #13+
            '  PROCEDA CON PRECAUCIN YA QUE LA EMPRESA Y TODOS SUS DATOS SERN ' +
            'ELIMINADOS Y NO SE PODRN RECUPERAR.',
            'Eliminar empresa...') then
          exit;
        if not fp.mssi('SEGUNDO MENSAJE DE CONFIRMACIN:  Est seguro que desea ' +
              'ELIMINAR la empresa ' + #13+#13+
              inttostr(codigo) + ' - ' + NombreEmpresa + #13+#13+#13+
              '  PROCEDA CON PRECAUCIN YA QUE LA EMPRESA Y TODOS SUS DATOS SERN ' +
              'ELIMINADOS Y NO SE PODRN RECUPERAR.',
              'Eliminar empresa...') then
          exit;
        atributos:=faAnyFile;
        if not fp.msok ('Se va a proceder a la eliminacin de la empresa.' + #13+#13+
             inttostr(codigo) + ' - ' + NombreEmpresa,
             'Eliminar empresa...') then
          exit;
        if FindFirst(rutacopia+ '\*.*', Atributos, Nombre) = 0 then
        begin
          try
            if (nombre.name<>'.') and (nombre.name<>'..') then
              deletefile(rutacopia + '\' +nombre.name);
          except
            //silenciosa
          end;
          while FindNext(nombre)=0 do
          begin
            try
              if (nombre.name<>'.') and (nombre.name<>'..') then
                deletefile(rutacopia + '\' + nombre.name);
            except
              //silenciosa
            end;
          end;
        end;
        findclose(nombre);
        try
          rmdir(rutacopia);
        except
          //silenciosa
        end;
      end;
      datos.tempresa.open;
      if datos.tempresa.Locate('Codigo', codigo, []) then
        datos.tempresa.delete;
      ActRefrescarExecute(nil);
      fp.msinfo ('La empresa se ha eliminado correctamente.',
        'Informacin...');
    end;
  end;
end;

procedure TFormEmpresas.ActModificarExecute(Sender: TObject);
begin
  if datos.TcEmpresa.recordcount <= 0 then
    fp.msinfo ('No hay datos', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario('modificacion', true) then
    begin
      formmenuprincipal.accion := 'modificar';
      datos.TEmpresa.Active := true;
      datos.TEmpresa.locate ('Codigo',
          datos.TCEmpresa.fieldbyname('Codigo').value,[]);
      datos.TEmpresa.edit;
      application.createform(tformempresag, formempresag);
      formempresag.Tag := 40;
      formempresag.ShowModal;
      ActRefrescarExecute(nil);      
    end;
  end;
end;

procedure TFormEmpresas.ActImprimirExecute(Sender: TObject);
begin
  if datos.tcempresa.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario ('localizar', false) then
    begin
      application.createform(tformImprimir, formImprimir);
      formimprimir.Tag := 40;
      formImprimir.showmodal;
    end;
  end;
end;

procedure TFormEmpresas.ActSeleccionarExecute(Sender: TObject);
begin
  if datos.TCEmpresa.recordcount <= 0 then
    fp.msinfo ('No hay datos', 'Informacin...')
  else
  begin
    formmenuprincipal.abrirempresa(datos.TCEmpresaCodigo.value);
    close;
  end;
end;

procedure TFormEmpresas.TablaDblClick(Sender: TObject);
begin
  ActSeleccionarExecute(nil);
end;

procedure TFormEmpresas.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TFormEmpresas.ActRefrescarExecute(Sender: TObject);
begin
  ordenar(campoOrdenado, segCampo);
end;

procedure TFormEmpresas.ActBuscarExecute(Sender: TObject);
begin
  if datos.TEmpresa.recordcount <= 0 then
    fp.msinfo ('No hay datos', 'Informacin...')
  else
  begin
    application.createform(tformLocalizar, formLocalizar);
    FormLocalizar.Tag := 40;
    formLocalizar.showmodal;
  end;
end;

procedure TFormEmpresas.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TFormEmpresas.ActNuevoExecute(Sender: TObject);
begin
  if fp.ComprobarUsuario('altas/bajas', true) then
  begin
    formmenuprincipal.accion := 'nuevo';
    application.createform(tformempresag, formempresag);
    formempresag.ShowModal;
    ActRefrescarExecute(nil);    
  end;
end;

procedure TFormEmpresas.TablaTitleClick(Column: TColumn);
begin
  campoOrdenado := column.fieldname;
  nombreCampoOrdenado := Column.Title.Caption;
  caption := ventanas + ' (ordenado por ' + Column.Title.Caption + ')';
  ordenar (campoOrdenado, segCampo);
end;

procedure TFormEmpresas.FormCreate(Sender: TObject);
var
  ruta : string;
begin
  datos.tempresa.close;
  datos.tcempresa.close;
  if formmenuprincipal.vtservidor = 1 then
    ruta := extractfilepath(application.exename)
  else
    ruta := formmenuprincipal.vtrutaservidor;
  datos.tempresa.databasename := ruta;
  datos.tcempresa.databasename := ruta;  
//  datos.tempresa.open;
  campoOrdenado := 'codigo';
  ordenar(campoOrdenado, segCampo);
  actcerrar.Hint := 'Cerrar ' + ventanas;
end;

end.
