unit UnidadGAparato;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,  Dialogs,
  StdCtrls, DBCtrls, Buttons, ExtCtrls, db, DBTables, Mask, forms;

type
  TFormAparatoG = class(TForm)
    Label3: TLabel;
    TxtNombre: TDBEdit;
    TxtCodigo: TDBEdit;
    Label8: TLabel;
    BSeleccionar: TSpeedButton;
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    Panel1: TPanel;
    Label1: TLabel;
    TxtImporteComision: TDBEdit;
    Label2: TLabel;
    TxtImporteVenta: TDBEdit;
    Label4: TLabel;
    TxtImporteCompra: TDBEdit;
    Label5: TLabel;
    DBMemo1: TDBMemo;
    DBCheckBox1: TDBCheckBox;
    LMoneda: TLabel;
    IEuro: TImage;
    IPeseta: TImage;
    BCambio: TButton;
    LMoneda2: TLabel;
    IEuro2: TImage;
    IPeseta2: TImage;
    BCambio2: TButton;
    LMoneda3: TLabel;
    IEuro3: TImage;
    IPeseta3: TImage;
    BCambio3: TButton;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarClick(Sender: TObject);
    procedure TxtCodigoKeyPress(Sender: TObject; var Key: Char);
    procedure TxtCodigoExit(Sender: TObject);
    procedure TxtNombreExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TxtCodigoChange(Sender: TObject);
    procedure TxtImporteComisionKeyPress(Sender: TObject; var Key: Char);
    procedure BCambioClick(Sender: TObject);
    procedure BCambio2Click(Sender: TObject);
    procedure BCambio3Click(Sender: TObject);
    procedure TxtImporteVentaKeyPress(Sender: TObject; var Key: Char);
    procedure TxtImporteCompraKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormAparatoG: TFormAparatoG;
const
  ventana = 'Aparato';
  ventanas = 'Aparatos';

implementation

uses UnidadDatos, UnidadMenuPrincipal, UnidadSeleccion;


{$R *.DFM}

var
  fp : tformmenuprincipal;

procedure TFormAparatoG.BCancelarClick(Sender: TObject);
begin
  try
    datos.TAparato.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TFormAparatoG.BAceptarClick(Sender: TObject);
begin
  if uppercase(LMoneda.caption) = uppercase('Pesetas') then
    datos.TAparatoImporteComisionE.value :=
        datos.TAparatoImporteComision.Value / FormMenuPrincipal.VTCambioMonedaEmpresa
  else
    datos.TAparatoImporteComision.value :=
        datos.TAparatoImporteComisionE.Value * FormMenuPrincipal.VTCambioMonedaEmpresa;
  if uppercase(LMoneda2.caption) = uppercase('Pesetas') then
    datos.TAparatoImporteVentaE.value :=
        datos.TAparatoImporteVenta.Value / FormMenuPrincipal.VTCambioMonedaEmpresa
  else
    datos.TAparatoImporteVenta.value :=
        datos.TAparatoImporteVentaE.Value * FormMenuPrincipal.VTCambioMonedaEmpresa;
  if uppercase(LMoneda3.caption) = uppercase('Pesetas') then
    datos.TAparatoImporteCompraE.value :=
        datos.TAparatoImporteCompra.Value / FormMenuPrincipal.VTCambioMonedaEmpresa
  else
    datos.TAparatoImporteCompra.value :=
        datos.TAparatoImporteCompraE.Value * FormMenuPrincipal.VTCambioMonedaEmpresa;
  if datos.taparato.State  in [dsinsert, dsedit] then
  begin
    try
      datos.TAparato.Post; //validar
    except
      TxtNombre.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TFormAparatoG.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  datos.TC.close;
  action := cafree;
end;

procedure TFormAparatoG.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TFormAparatoG.BSeleccionarClick(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  Formseleccion.Caption := 'Seleccin de ' + ventana + '...';
  formseleccion.tag := 30;
  formseleccion.ActNuevo.Enabled := false;
  formseleccion.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    TxtCodigo.Text := formmenuprincipal.claveelegida;
end;

procedure TFormAparatoG.TxtCodigoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '+' then
  begin
    key := chr(0);
    BSeleccionarclick(nil);
  end;
end;

procedure TFormAparatoG.TxtCodigoExit(Sender: TObject);
begin
  if FormMenuPrincipal.accion = 'nuevo' then
  begin
    if txtcodigo.text = '' then
    begin
      fp.msError ('El cdigo debe contener un valor.', 'Error...');
      txtcodigo.SelectAll;
      txtcodigo.setfocus;
    end;
    datos.tc.close;
    datos.tc.sql.Clear;
    datos.tc.SQL.add('SELECT count(Codigo) C FROM ' + ventana);
    datos.tc.sql.add('WHERE Codigo = "' + txtcodigo.text + '"');
    datos.tc.ExecSQL;
    datos.tc.open;
    if datos.tc.fieldbyname('C').value > 0 then
    begin
      fp.msError ('Ya existe un ' + ventana + ' con este cdigo.', 'Error...');
      txtcodigo.SelectAll;
      txtcodigo.setfocus;
    end;
    datos.tc.Close;
  end;
end;

procedure TFormAparatoG.TxtNombreExit(Sender: TObject);
begin
  if txtnombre.text = '' then
  begin
    fp.msError ('La descripcin debe contener un valor.', 'Error...');
    txtnombre.SelectAll;
    txtnombre.setfocus;
  end;
  if formmenuprincipal.accion = 'nuevo' then
  begin
    datos.tc.close;
    datos.tc.sql.Clear;
    datos.tc.SQL.add('SELECT count(Nombre) C FROM ' + ventana);
    datos.tc.sql.add('WHERE upper(Nombre) = "' + uppercase(txtnombre.text) + '"');
    datos.tc.ExecSQL;
    datos.tc.open;
    if datos.tc.fieldbyname('C').value > 0 then
    begin
      fp.msError ('Ya existe un ' + ventana + ' con esta descripcin.', 'Error...');
      txtnombre.SelectAll;
      txtnombre.setfocus;
    end;
    datos.tc.Close;
  end;
end;

procedure TFormAparatoG.FormShow(Sender: TObject);
begin
  if formmenuprincipal.leBoolINI ('Aplicacion', cintroducireuros, False) then //Euros
  begin
    BCambioClick(nil);
    BCambio2Click(nil);
    BCambio3Click(nil);
  end;
  datos.taparato.open;
  if formmenuprincipal.accion = 'nuevo' then
  begin
    txtcodigo.setfocus;
    caption := 'Nuevo ' + ventana + '...';;
    datos.TAparato.Insert;
    datos.TAparatoPlus.Value := true;    
  end;
  if formmenuprincipal.accion = 'modificar' then
  begin
    txtnombre.setfocus;
    txtcodigo.Enabled := false;
    bseleccionar.Visible := false;
    caption := 'Modificar ' + ventana + '...';
  end;
  if formmenuprincipal.accion = 'zoom' then
  begin
    datos.taparato.locate ('Codigo', formmenuprincipal.codigo,[]);
    caption := 'Visualizar ' + ventana + '...';
    bseleccionar.Visible := false;
    baceptar.Visible := false;
    bcancelar.SetFocus;
  end;
end;

procedure TFormAparatoG.TxtCodigoChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txtcodigo.text) = 4 then
      txtnif.setfocus;
  end;}
end;

procedure TFormAparatoG.TxtImporteComisionKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
  if key = '+' then
  begin
    BCambioClick(nil);
    key := #0;
  end;
end;

procedure TFormAparatoG.BCambioClick(Sender: TObject);
begin
  if uppercase(LMoneda.caption) = uppercase('Pesetas') then
  begin
    TxtImporteComision.dataField := 'ImporteComisionE';
    IPeseta.Visible := false;
    IEuro.Visible := true;
    LMoneda.Caption := 'Euros';
  end
  else
  begin
    TxtImporteComision.dataField := 'ImporteComision';
    IPeseta.Visible := true;
    IEuro.Visible := false;
    LMoneda.Caption := 'Pesetas';
  end;
  TxtImporteComision.SelectAll;
  TxtImporteComision.SetFocus;
end;

procedure TFormAparatoG.BCambio2Click(Sender: TObject);
begin
  if uppercase(LMoneda2.caption) = uppercase('Pesetas') then
  begin
    TxtImporteVenta.dataField := 'ImporteVentaE';
    IPeseta2.Visible := false;
    IEuro2.Visible := true;
    LMoneda2.Caption := 'Euros';
  end
  else
  begin
    TxtImporteVenta.dataField := 'ImporteVenta';
    IPeseta2.Visible := true;
    IEuro2.Visible := False;
    LMoneda2.Caption := 'Pesetas';
  end;
  TxtImporteVenta.SelectAll;
  TxtImporteVenta.SetFocus;
end;

procedure TFormAparatoG.BCambio3Click(Sender: TObject);
begin
  if uppercase(LMoneda3.caption) = uppercase('Pesetas') then
  begin
    TxtImporteCompra.dataField := 'ImporteCompraE';
    IPeseta3.Visible := false;
    IEuro3.Visible := true;
    Lmoneda3.Caption := 'Euros';
  end
  else
  begin
    TxtImporteCompra.dataField := 'ImporteCompra';
    IPeseta3.Visible := true;
    IEuro3.Visible := false;
    Lmoneda3.Caption := 'Pesetas';
  end;
  TxtImporteCompra.SelectAll;
  TxtImporteCompra.SetFocus;
end;

procedure TFormAparatoG.TxtImporteVentaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
  if key = '+' then
  begin
    BCambio2Click(nil);
    key := #0;
  end;
end;

procedure TFormAparatoG.TxtImporteCompraKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '.' then
    key := ',';
  if key = '+' then
  begin
    BCambio3Click(nil);
    key := #0;
  end;
end;

end.
