unit UnidadGCobro;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,  Dialogs,
  StdCtrls, DBCtrls, Buttons, ExtCtrls, db, DBTables, Mask, forms;

type
  TFormCobroG = class(TForm)
    BSeleccionarCliente: TSpeedButton;
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    Panel1: TPanel;
    Label1: TLabel;
    TxtFecha: TDBEdit;
    Label3: TLabel;
    TxtImporte: TDBEdit;
    DBEdit4: TDBEdit;
    Label4: TLabel;
    LBCliente: TDBText;
    Label5: TLabel;
    TxtCodigoCliente: TDBEdit;
    TxtCodigoComercial: TDBEdit;
    Label6: TLabel;
    BSeleccionarComercial: TSpeedButton;
    DBText2: TDBText;
    BSeleccionarFecha: TSpeedButton;
    BCambio: TButton;
    LMoneda: TLabel;
    IPeseta: TImage;
    IEuro: TImage;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarClienteClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TxtCPChange(Sender: TObject);
    procedure TxtTelefonoChange(Sender: TObject);
    procedure TxtCodigoClienteKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarComercialClick(Sender: TObject);
    procedure TxtCodigoComercialKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarFechaClick(Sender: TObject);
    procedure TxtFechaKeyPress(Sender: TObject; var Key: Char);
    procedure TxtImporteKeyPress(Sender: TObject; var Key: Char);
    procedure BEuroClick(Sender: TObject);
    procedure BCambioClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormCobroG: TFormCobroG;
const
  ventana = 'Cobro';
  ventanas = 'Cobros';

implementation

uses UnidadDatos, UnidadMenuPrincipal, UnidadSeleccion, UnidadCalendario;


{$R *.DFM}

var
  fp : tformmenuprincipal;

procedure TFormCobroG.BCancelarClick(Sender: TObject);
begin
  try
    datos.tcobro.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TFormCobroG.BAceptarClick(Sender: TObject);
begin
 if (txtfecha.text = '  /  /  ') or (txtfecha.text = '') then
  begin
    fp.msError ('Debe introducir una fecha.', 'Faltan datos...');
    txtfecha.SelectAll;
    txtfecha.setfocus;
    exit;
  end;
  if datos.TCobroNombreCliente.Value = '' then
  begin
    fp.msError ('No existe ningn cliente con el cdigo: ' +
        TxtCodigoCliente.text + '.', 'Faltan datos...');
    txtcodigocliente.SelectAll;
    txtcodigocliente.setfocus;
    exit;
  end;
  if datos.TCobroNombreComercial.Value = '' then
  begin
    fp.msError ('No existe ningn comercial con el cdigo: ' +
        TxtCodigoComercial.text + '.', 'Faltan datos...');
    txtcodigocomercial.SelectAll;
    txtcodigocomercial.setfocus;
    exit;    
  end;
  if uppercase(LMoneda.caption) = uppercase('Pesetas') then 
    datos.tcobroimportee.value :=
        datos.TCobroImporte.Value / FormMenuPrincipal.VTCambioMonedaEmpresa
  else
    datos.tcobroimporte.value :=
        datos.TCobroImportee.Value * FormMenuPrincipal.VTCambioMonedaEmpresa;
  if datos.tcobro.State  in [dsinsert, dsedit] then
  begin
    try
      datos.tcobro.Post; //validar
    except
      txtfecha.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TFormCobroG.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  datos.TC.close;
  action := cafree;
end;

procedure TFormCobroG.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TFormCobroG.BSeleccionarClienteClick(Sender: TObject);
begin
  txtcodigocliente.setfocus;
  application.createform(tformseleccion, formseleccion);
  Formseleccion.Caption := 'Seleccin de ' + ventana + '...';
  formseleccion.tag := 50;
  formseleccion.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
  begin
    if FormMenuPrincipal.claveelegida <> '' then
    begin
      TxtCodigoCliente.Text := formmenuprincipal.claveelegida;
      txtcodigocomercial.setfocus;
    end;
  end;
end;

procedure TFormCobroG.FormShow(Sender: TObject);
begin
  if formmenuprincipal.leBoolINI ('Aplicacion', cintroducireuros, False) then //Euros
    BCambioClick(nil);
  datos.tcomercial.open;
  //datos.tcliente.open;
  txtfecha.SetFocus;
  if formmenuprincipal.accion = 'nuevo' then
  begin
    caption := 'Nuevo ' + ventana + '...';;
    datos.tcobro.Active := true;
    datos.tcobro.Insert;
    datos.TCobroFecha.value := formmenuprincipal.VTFechaTrabajo;
  end;
  if formmenuprincipal.accion = 'modificar' then
  begin
    caption := 'Modificar ' + ventana + '...';
  end;
  if formmenuprincipal.accion = 'zoom' then
  begin
    datos.tcobro.Active := true;
    datos.tcobro.locate ('Codigo', formmenuprincipal.codigo,[]);
    caption := 'Visualizar ' + ventana + '...';
    BSeleccionarCliente.Visible := false;
    BSeleccionarComercial.Visible := false;
    BSeleccionarFecha.Visible := false;
    baceptar.Visible := false;
    bcancelar.SetFocus;
  end;
end;

procedure TFormCobroG.TxtCPChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txtcp.text) = 5 then
      txttelefono.setfocus;
  end;}
end;

procedure TFormCobroG.TxtTelefonoChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txttelefono.text) = 9 then
      opIVA.setfocus;
  end;}
end;

procedure TFormCobroG.TxtCodigoClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (key = '+') and (FormMenuPrincipal.accion <> 'zoom') then
  begin
    key := chr(0);
    BSeleccionarClienteclick(nil);
  end;
end;

procedure TFormCobroG.BSeleccionarComercialClick(Sender: TObject);
begin
  txtcodigocomercial.setfocus;
  application.createform(tformseleccion, formseleccion);
  Formseleccion.Caption := 'Seleccin de ' + ventana + '...';
  formseleccion.tag := 10;
  formseleccion.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
  begin
    if FormMenuPrincipal.claveelegida <> '' then
    begin
      TxtCodigoComercial.Text := formmenuprincipal.claveelegida;
      Perform(WM_NEXTDLGCTL, 0, 0);
    end;
  end;
end;

procedure TFormCobroG.TxtCodigoComercialKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (key = '+') and (FormMenuPrincipal.accion <> 'zoom') then
  begin
    key := chr(0);
    BSeleccionarComercialclick(nil);
  end;
end;

procedure TFormCobroG.BSeleccionarFechaClick(Sender: TObject);
begin
  application.createform(tformCalendario, formCalendario);
  formCalendario.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    if FormMenuPrincipal.claveelegida <> '' then
      TxtFecha.Text := formmenuprincipal.claveelegida;
end;

procedure TFormCobroG.TxtFechaKeyPress(Sender: TObject; var Key: Char);
begin
  if (key = '+') and (FormMenuPrincipal.accion <> 'zoom') then
  begin
    key := chr(0);
    BSeleccionarfechaclick(nil);
  end;
end;

procedure TFormCobroG.TxtImporteKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
  if key = '+' then
  begin
    BCambioClick(nil);
    key := #0;
  end;
end;

procedure TFormCobroG.BEuroClick(Sender: TObject);
begin
  TxtImporte.dataField := 'ImporteE';
end;

procedure TFormCobroG.BCambioClick(Sender: TObject);
begin
  if uppercase(LMoneda.caption) = uppercase('Pesetas') then
  begin
    TxtImporte.dataField := 'ImporteE';
    IPeseta.Visible := false;
    IEuro.Visible := true;
    LMoneda.Caption := 'Euros';
  end
  else
  begin
    TxtImporte.dataField := 'Importe';
    IPeseta.Visible := true;
    IEuro.Visible := false;
    LMoneda.Caption := 'Pesetas';
  end;
end;

end.
