unit UnidadGComerial;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,  Dialogs,
  StdCtrls, DBCtrls, Buttons, ExtCtrls, db, DBTables, Mask, forms;

type
  TFormComercialG = class(TForm)
    Label1: TLabel;
    TxtNIF: TDBEdit;
    Label2: TLabel;
    Label3: TLabel;
    TxtNombre: TDBEdit;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    Label6: TLabel;
    DBEdit6: TDBEdit;
    Label7: TLabel;
    TxtCP: TDBEdit;
    OpIVA: TDBCheckBox;
    TxtTipo: TDBComboBox;
    TxtCodigo: TDBEdit;
    Label8: TLabel;
    TxtTelefono: TDBEdit;
    Label9: TLabel;
    Label10: TLabel;
    DBMemo1: TDBMemo;
    BSeleccionar: TSpeedButton;
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    Panel1: TPanel;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure TxtTipoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TxtNIFExit(Sender: TObject);
    procedure BSeleccionarClick(Sender: TObject);
    procedure TxtCodigoKeyPress(Sender: TObject; var Key: Char);
    procedure TxtCodigoExit(Sender: TObject);
    procedure TxtNombreExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TxtCodigoChange(Sender: TObject);
    procedure TxtNIFChange(Sender: TObject);
    procedure TxtCPChange(Sender: TObject);
    procedure TxtTelefonoChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormComercialG: TFormComercialG;
const
  ventana = 'Comercial';
  ventanas = 'Comerciales';

implementation

uses UnidadDatos, UnidadMenuPrincipal, UnidadSeleccion;


{$R *.DFM}

var
  fp : tformmenuprincipal;

procedure TFormComercialG.BCancelarClick(Sender: TObject);
begin
  try
    datos.TComercial.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TFormComercialG.BAceptarClick(Sender: TObject);
begin
  if datos.tcomercial.State  in [dsinsert, dsedit] then
  begin
    try
      datos.TComercial.Post; //validar
    except
      txtnif.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TFormComercialG.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  datos.TC.close;
  action := cafree;
end;

procedure TFormComercialG.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TFormComercialG.TxtTipoKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if key = 40 then  // flecha abajo -> desplegar
    txttipo.Perform(CB_SHOWDROPDOWN, 1,0);
end;

procedure TFormComercialG.TxtNIFExit(Sender: TObject);
var
  nif : string;
begin
  if (formmenuprincipal.accion = 'modificar') or
      (formmenuprincipal.accion = 'nuevo') then
  begin
    if txtnif.text = '' then
    begin
      fp.msError ('El NIF debe contener un valor.', 'Error...');
      txtnif.SelectAll;
      txtnif.setfocus;
      exit;
    end;
    nif := datos.TComercialNIF.Value;
    if fp.letranif(nif) <> ' ' then
    begin
      nif := nif + '-' + fp.letraNif(nif);
      if Datos.DComercial.DataSet.State IN [dsedit, dsinsert] then
        datos.TComercialNIF.Value := nif;
    end;
    if formmenuprincipal.accion = 'nuevo' then
    begin
      with datos.tc do
      begin
        close;
        sql.Clear;
        SQL.add('SELECT count(NIF) C FROM ' + ventana);
        sql.add('WHERE NIF = "' + txtnif.text + '"');
        ExecSQL;
        open;
        if fieldbyname('C').value > 0 then
        begin
          fp.msError ('Ya existe un ' + ventana + ' con este NIF.', 'Error...');
          txtnif.SelectAll;
          txtnif.setfocus;
          exit;
        end;
        Close;
      end;
    end;
  end;
end;

procedure TFormComercialG.BSeleccionarClick(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  Formseleccion.Caption := 'Seleccin de ' + ventana + '...';
  formseleccion.tag := 10;
  formseleccion.ActNuevo.Enabled := false;
  formseleccion.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    TxtCodigo.Text := formmenuprincipal.claveelegida;
end;

procedure TFormComercialG.TxtCodigoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = '+' then
  begin
    key := chr(0);
    BSeleccionarclick(nil);
  end;
end;

procedure TFormComercialG.TxtCodigoExit(Sender: TObject);
begin
  if FormMenuPrincipal.accion = 'nuevo' then
  begin
    if txtcodigo.text = '' then
    begin
      fp.msError ('El cdigo debe contener un valor.', 'Error...');
      txtcodigo.SelectAll;
      txtcodigo.setfocus;
    end;
    datos.tc.close;
    datos.tc.DatabaseName := 'Comisiones';
    datos.tc.sql.Clear;
    datos.tc.SQL.add('SELECT count(Codigo) C FROM ' + ventana);
    datos.tc.sql.add('WHERE Codigo = "' + txtcodigo.text + '"');
//    datos.tc.ExecSQL;
    datos.tc.open;
    if datos.tc.fieldbyname('C').value > 0 then
    begin
      fp.msError ('Ya existe un ' + ventana + ' con este cdigo.', 'Error...');
      txtcodigo.SelectAll;
      txtcodigo.setfocus;
    end;
    datos.tc.Close;
  end;
end;

procedure TFormComercialG.TxtNombreExit(Sender: TObject);
begin
  if txtnombre.text = '' then
  begin
    fp.msError ('El nombre debe contener un valor.', 'Error...');
    txtnombre.SelectAll;
    txtnombre.setfocus;
  end;
  if formmenuprincipal.accion = 'nuevo' then
  begin
    datos.tc.close;
    datos.tc.DatabaseName := 'Comisiones';
    datos.tc.sql.Clear;
    datos.tc.SQL.add('SELECT count(Nombre) C FROM ' + ventana);
    datos.tc.sql.add('WHERE upper(Nombre) = "' + uppercase(txtnombre.text) + '"');
//    datos.tc.ExecSQL;
    datos.tc.open;
    if datos.tc.fieldbyname('C').value > 0 then
    begin
      fp.msError ('Ya existe un ' + ventana + ' con este nombre.', 'Error...');
      txtnombre.SelectAll;
      txtnombre.setfocus;
    end;
    datos.tc.Close;
  end;
end;

procedure TFormComercialG.FormShow(Sender: TObject);
begin
  if formmenuprincipal.accion = 'nuevo' then
  begin
    caption := 'Nuevo ' + ventana + '...';;
    datos.tcomercial.Active := true;
    datos.TComercial.Insert;
    datos.TComercialIVA.Value := true;
  end;
  if formmenuprincipal.accion = 'modificar' then
  begin
    txtcodigo.Enabled := false;
    bseleccionar.Visible := false;    
    caption := 'Modificar ' + ventana + '...';
  end;
  if formmenuprincipal.accion = 'zoom' then
  begin
    datos.tcomercial.Active := true;
    datos.tcomercial.locate ('Codigo', formmenuprincipal.codigo,[]);
    caption := 'Visualizar ' + ventana + '...';
    bseleccionar.Visible := false;
    baceptar.Visible := false;
    txttipo.Enabled := false;
    bcancelar.SetFocus;
  end;
end;

procedure TFormComercialG.TxtCodigoChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txtcodigo.text) = 4 then
      txtnif.setfocus;
  end;}
end;

procedure TFormComercialG.TxtNIFChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txtnif.text) = 8 then
      txtnombre.setfocus;
  end;}
end;

procedure TFormComercialG.TxtCPChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txtcp.text) = 5 then
      txttelefono.setfocus;
  end;}
end;

procedure TFormComercialG.TxtTelefonoChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txttelefono.text) = 9 then
      opIVA.setfocus;
  end;}
end;

end.
