unit UnidadGExtra;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,  Dialogs,
  StdCtrls, DBCtrls, Buttons, ExtCtrls, db, DBTables, Mask, forms;

type
  TFormExtraG = class(TForm)
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    Panel1: TPanel;
    Label1: TLabel;
    TxtFecha: TDBEdit;
    Label3: TLabel;
    TxtImporte: TDBEdit;
    TxtCodigoComercial: TDBEdit;
    Label6: TLabel;
    BSeleccionarComercial: TSpeedButton;
    DBText2: TDBText;
    BSeleccionarFecha: TSpeedButton;
    Label2: TLabel;
    TxtNombre: TDBEdit;
    LMoneda: TLabel;
    IEuro: TImage;
    IPeseta: TImage;
    BCambio: TButton;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure TxtCPChange(Sender: TObject);
    procedure TxtTelefonoChange(Sender: TObject);
    procedure BSeleccionarComercialClick(Sender: TObject);
    procedure TxtCodigoComercialKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarFechaClick(Sender: TObject);
    procedure TxtFechaKeyPress(Sender: TObject; var Key: Char);
    procedure TxtImporteKeyPress(Sender: TObject; var Key: Char);
    procedure BCambioClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormExtraG: TFormExtraG;
const
  ventana = 'Extra';
  ventanas = 'Extras';

implementation

uses UnidadDatos, UnidadMenuPrincipal, UnidadSeleccion, UnidadCalendario;


{$R *.DFM}

var
  fp : tformmenuprincipal;

procedure TFormExtraG.BCancelarClick(Sender: TObject);
begin
  try
    datos.textra.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TFormExtraG.BAceptarClick(Sender: TObject);
begin
 if (txtfecha.text = '  /  /  ') or (txtfecha.text = '') then
  begin
    fp.msError ('Debe introducir una fecha.', 'Faltan datos...');
    txtfecha.SelectAll;
    txtfecha.setfocus;
    exit;
  end;
  if datos.TExtraNombreComercial.Value = '' then
  begin
    fp.msError ('No existe ningn comercial con el cdigo: ' +
        TxtCodigoComercial.text + '.', 'Faltan datos...');
    txtcodigocomercial.SelectAll;
    txtcodigocomercial.setfocus;
    exit;
  end;
  if uppercase(LMoneda.caption) = uppercase('Pesetas') then 
    datos.textraimportee.value :=
        datos.TextraImporte.Value / FormMenuPrincipal.VTCambioMonedaEmpresa
  else
    datos.textraimporte.value :=
        datos.TextraImportee.Value * FormMenuPrincipal.VTCambioMonedaEmpresa;
  if datos.textra.State  in [dsinsert, dsedit] then
  begin
    try
      datos.textra.Post; //validar
    except
      txtfecha.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TFormExtraG.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  datos.TC.close;
  screen.Cursor := crDefault;
  action := cafree;
end;

procedure TFormExtraG.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TFormExtraG.FormShow(Sender: TObject);
begin
  if formmenuprincipal.leBoolINI ('Aplicacion', cintroducireuros, False) then //Euros
    BCambioClick(nil);
  datos.tcomercial.open;
  TxtFecha.setfocus;
  if formmenuprincipal.accion = 'nuevo' then
  begin
    caption := 'Nuevo ' + ventana + '...';;
    datos.textra.Active := true;
    datos.textra.Insert;
    datos.TExtraFecha.value := formmenuprincipal.VTFechaTrabajo;
  end;
  if formmenuprincipal.accion = 'modificar' then
  begin
    caption := 'Modificar ' + ventana + '...';
  end;
  if formmenuprincipal.accion = 'zoom' then
  begin
    datos.textra.Active := true;
    datos.textra.locate ('Codigo', formmenuprincipal.codigo,[]);
    caption := 'Visualizar ' + ventana + '...';
    BSeleccionarComercial.Visible := false;
    BSeleccionarFecha.Visible := false;
    baceptar.Visible := false;
    bcancelar.SetFocus;
  end;
end;

procedure TFormExtraG.TxtCPChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txtcp.text) = 5 then
      txttelefono.setfocus;
  end;}
end;

procedure TFormExtraG.TxtTelefonoChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txttelefono.text) = 9 then
      opIVA.setfocus;
  end;}
end;

procedure TFormExtraG.BSeleccionarComercialClick(Sender: TObject);
begin
  txtcodigocomercial.setfocus;
  application.createform(tformseleccion, formseleccion);
  Formseleccion.Caption := 'Seleccin de ' + ventana + '...';
  formseleccion.tag := 10;
  formseleccion.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
  begin
    if FormMenuPrincipal.claveelegida <> '' then
    begin
      TxtCodigoComercial.Text := formmenuprincipal.claveelegida;
      Perform(WM_NEXTDLGCTL, 0, 0);
    end;
  end;
end;

procedure TFormExtraG.TxtCodigoComercialKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (key = '+') and (FormMenuPrincipal.accion <> 'zoom') then
  begin
    key := chr(0);
    BSeleccionarComercialclick(nil);
  end;
end;

procedure TFormExtraG.BSeleccionarFechaClick(Sender: TObject);
begin
  application.createform(tformCalendario, formCalendario);
  formCalendario.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    if FormMenuPrincipal.claveelegida <> '' then
      TxtFecha.Text := formmenuprincipal.claveelegida;
end;

procedure TFormExtraG.TxtFechaKeyPress(Sender: TObject; var Key: Char);
begin
  if (key = '+') and (FormMenuPrincipal.accion <> 'zoom') then
  begin
    key := chr(0);
    BSeleccionarfechaclick(nil);
  end;
end;

procedure TFormExtraG.TxtImporteKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
  if key = '+' then
  begin
    BCambioClick(nil);
    key := #0;
  end;
end;

procedure TFormExtraG.BCambioClick(Sender: TObject);
begin
  if uppercase(LMoneda.caption) = uppercase('Pesetas') then
  begin
    TxtImporte.dataField := 'ImporteE';
    IPeseta.Visible := false;
    IEuro.Visible := true;
    LMoneda.Caption := 'Euros';
  end
  else
  begin
    TxtImporte.dataField := 'Importe';
    IPeseta.Visible := true;
    IEuro.Visible := false;
    LMoneda.Caption := 'Pesetas';
  end;
  txtimporte.SelectAll;
  txtimporte.SetFocus;
end;

end.
