unit UnidadGPlus;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,  Dialogs,
  StdCtrls, DBCtrls, Buttons, ExtCtrls, db, DBTables, Mask, forms, ComCtrls;

type
  TFormPlusG = class(TForm)
    TxtCodigo: TDBEdit;
    Label8: TLabel;
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    Panel1: TPanel;
    Label1: TLabel;
    DBEdit1: TDBEdit;
    Label2: TLabel;
    TxtImporte: TDBEdit;
    Label3: TLabel;
    TxtNombre: TDBEdit;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    LMoneda: TLabel;
    IEuro: TImage;
    IPeseta: TImage;
    BCambio: TButton;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure TxtCodigoExit(Sender: TObject);
    procedure TxtNombreExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TxtCodigoChange(Sender: TObject);
    procedure TxtImporteKeyPress(Sender: TObject; var Key: Char);
    procedure TxtCodigoKeyPress(Sender: TObject; var Key: Char);
    procedure BCambioClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormPlusG: TFormPlusG;
const
  ventana = 'Plus';
  ventanas = 'Plus';

implementation

uses UnidadDatos, UnidadMenuPrincipal, UnidadSeleccion;


{$R *.DFM}

var
  fp : tformmenuprincipal;

procedure TFormPlusG.BCancelarClick(Sender: TObject);
begin
  try
    datos.tplus.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TFormPlusG.BAceptarClick(Sender: TObject);
begin
  if uppercase(LMoneda.caption) = uppercase('Pesetas') then
    datos.TPlusImporteE.value :=
        datos.TplusImporte.Value / FormMenuPrincipal.VTCambioMonedaEmpresa
  else
    datos.tplusimporte.value :=
        datos.TplusImportee.Value * FormMenuPrincipal.VTCambioMonedaEmpresa;
  if datos.tplus.State  in [dsinsert, dsedit] then
  begin
    try
      datos.tplus.Post; //validar
    except
      TxtNombre.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TFormPlusG.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  datos.TC.close;
  action := cafree;
end;

procedure TFormPlusG.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TFormPlusG.TxtCodigoExit(Sender: TObject);
begin
  if FormMenuPrincipal.accion = 'nuevo' then
  begin
    if txtcodigo.text = '' then
    begin
      fp.msError ('El cdigo debe contener un valor.', 'Error...');
      txtcodigo.SelectAll;
      txtcodigo.setfocus;
    end;
    datos.tc.close;
    datos.tc.DatabaseName := 'Comisiones';
    datos.tc.sql.Clear;
    datos.tc.SQL.add('SELECT count(Codigo) C FROM ' + ventana);
    datos.tc.sql.add('WHERE Codigo = "' + txtcodigo.text + '"');
//    datos.tc.ExecSQL;
    datos.tc.open;
    if datos.tc.fieldbyname('C').value > 0 then
    begin
      fp.msError ('Ya existe un ' + ventana + ' con este cdigo.', 'Error...');
      txtcodigo.SelectAll;
      txtcodigo.setfocus;
    end;
    datos.tc.Close;
  end;
end;

procedure TFormPlusG.TxtNombreExit(Sender: TObject);
begin
  if txtnombre.text = '' then
  begin
    fp.msError ('La descripcin debe contener un valor.', 'Error...');
    txtnombre.SelectAll;
    txtnombre.setfocus;
  end;
  if formmenuprincipal.accion = 'nuevo' then
  begin
    datos.tc.close;
    datos.tc.DatabaseName := 'Comisiones';
    datos.tc.sql.Clear;
    datos.tc.SQL.add('SELECT count(Nombre) C FROM ' + ventana);
    datos.tc.sql.add('WHERE upper(Nombre) = "' + uppercase(txtnombre.text) + '"');
//    datos.tc.ExecSQL;
    datos.tc.open;
    if datos.tc.fieldbyname('C').value > 0 then
    begin
      fp.msError ('Ya existe un ' + ventana + ' con esta descripcin.', 'Error...');
      txtnombre.SelectAll;
      txtnombre.setfocus;
    end;
    datos.tc.Close;
  end;
end;

procedure TFormPlusG.FormShow(Sender: TObject);
begin
  if formmenuprincipal.leBoolINI ('Aplicacion', cintroducireuros, False) then //Euros
    BCambioClick(nil);
  datos.tplus.open;
  if formmenuprincipal.accion = 'nuevo' then
  begin
    TxtCodigo.setfocus;
    caption := 'Nuevo ' + ventana + '...';;
    datos.tplus.Insert;
  end;
  if formmenuprincipal.accion = 'modificar' then
  begin
    txtnombre.SetFocus;
    txtcodigo.Enabled := false;
    caption := 'Modificar ' + ventana + '...';
  end;
  if formmenuprincipal.accion = 'zoom' then
  begin
    datos.tplus.locate ('Codigo', formmenuprincipal.codigo,[]);
    caption := 'Visualizar ' + ventana + '...';
    baceptar.Visible := false;
    bcancelar.SetFocus;
  end;
end;

procedure TFormPlusG.TxtCodigoChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txtcodigo.text) = 4 then
      txtnif.setfocus;
  end;}
end;

procedure TFormPlusG.TxtImporteKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
  if key = '+' then
  begin
    BCambioClick(nil);
    key := #0;
  end;
end;

procedure TFormPlusG.TxtCodigoKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '+' then
    key := chr(0);
end;

procedure TFormPlusG.BCambioClick(Sender: TObject);
begin
  if uppercase(LMoneda.caption) = uppercase('Pesetas') then
  begin
    TxtImporte.dataField := 'ImporteE';
    IPeseta.Visible := false;
    IEuro.Visible := true;
    LMoneda.Caption := 'Euros';
  end
  else
  begin
    TxtImporte.dataField := 'Importe';
    IPeseta.Visible := true;
    IEuro.Visible := false;
    LMoneda.Caption := 'Pesetas';
  end;
  txtimporte.SelectAll;
  txtimporte.setfocus;
end;

end.
