unit UnidadGVenta;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,  Dialogs,
  StdCtrls, DBCtrls, Buttons, ExtCtrls, db, DBTables, Mask, forms;

type
  TFormVentaG = class(TForm)
    BSeleccionarCliente: TSpeedButton;
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    Panel1: TPanel;
    Label1: TLabel;
    TxtFecha: TDBEdit;
    Label3: TLabel;
    TxtImporte: TDBEdit;
    LBCliente: TDBText;
    Label5: TLabel;
    TxtCodigoCliente: TDBEdit;
    TxtCodigoComercial: TDBEdit;
    Label6: TLabel;
    BSeleccionarComercial: TSpeedButton;
    DBText2: TDBText;
    BSeleccionarFecha: TSpeedButton;
    Label2: TLabel;
    TxtFechaInstalacion: TDBEdit;
    BSeleccionarFechaInstalacion: TSpeedButton;
    Label4: TLabel;
    TxtCodigoAparato: TDBEdit;
    BSeleccionarAparato: TSpeedButton;
    DBText1: TDBText;
    Label7: TLabel;
    DBMemo1: TDBMemo;
    DBCheckBox1: TDBCheckBox;
    Label8: TLabel;
    DBEdit1: TDBEdit;
    LMoneda: TLabel;
    IEuro: TImage;
    IPeseta: TImage;
    BCambio: TButton;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarClienteClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TxtCPChange(Sender: TObject);
    procedure TxtTelefonoChange(Sender: TObject);
    procedure TxtCodigoClienteKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarComercialClick(Sender: TObject);
    procedure TxtCodigoComercialKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarFechaClick(Sender: TObject);
    procedure TxtFechaKeyPress(Sender: TObject; var Key: Char);
    procedure TxtImporteKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarFechaInstalacionClick(Sender: TObject);
    procedure BSeleccionarAparatoClick(Sender: TObject);
    procedure TxtCodigoAparatoKeyPress(Sender: TObject; var Key: Char);
    procedure TxtFechaInstalacionKeyPress(Sender: TObject; var Key: Char);
    procedure BCambioClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormVentaG: TFormVentaG;
const
  ventana = 'Venta';
  ventanas = 'Ventas';

implementation

uses UnidadDatos, UnidadMenuPrincipal, UnidadSeleccion, UnidadCalendario;


{$R *.DFM}

var
  fp : tformmenuprincipal;

procedure TFormVentaG.BCancelarClick(Sender: TObject);
begin
  try
    datos.tcobro.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TFormVentaG.BAceptarClick(Sender: TObject);
begin
 if (txtfecha.text = '  /  /  ') or (txtfecha.text = '') then
  begin
    fp.msError ('Debe introducir una fecha.', 'Faltan datos...');
    txtfecha.SelectAll;
    txtfecha.setfocus;
    exit;
  end;
  if datos.TVentaNombreCliente.Value = '' then
  begin
    fp.msError ('No existe ningn cliente con el cdigo: ' +
        TxtCodigoCliente.text + '.', 'Faltan datos...');
    txtcodigocliente.SelectAll;
    txtcodigocliente.setfocus;
    exit;
  end;
  if datos.TVentaNombreComercial.Value = '' then
  begin
    fp.msError ('No existe ningn comercial con el cdigo: ' +
        TxtCodigoComercial.text + '.', 'Faltan datos...');
    txtcodigocomercial.SelectAll;
    txtcodigocomercial.setfocus;
    exit;
  end;
  if datos.TVentaNombreAparato.Value = '' then
  begin
    fp.msError ('No existe ningn aparato con el cdigo: ' +
        TxtCodigoAparato.text + '.', 'Faltan datos...');
    txtcodigoaparato.SelectAll;
    txtcodigoaparato.setfocus;
    exit;
  end;
  if uppercase(LMoneda.caption) = uppercase('Pesetas') then
    datos.TVentaImporteE.value :=
        datos.TventaImporte.Value / FormMenuPrincipal.VTCambioMonedaEmpresa
  else
    datos.tventaimporte.value :=
        datos.TventaImportee.Value * FormMenuPrincipal.VTCambioMonedaEmpresa;
  if datos.tVenta.State  in [dsinsert, dsedit] then
  begin
    try
      datos.tventa.Post; //validar
    except
      txtfecha.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TFormVentaG.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  datos.TC.close;
  action := cafree;
end;

procedure TFormVentaG.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TFormVentaG.BSeleccionarClienteClick(Sender: TObject);
begin
  txtcodigocliente.setfocus;
  application.createform(tformseleccion, formseleccion);
  Formseleccion.Caption := 'Seleccin de cliente...';
  formseleccion.tag := 50;
  formseleccion.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
  begin
    if FormMenuPrincipal.claveelegida <> '' then
    begin
      TxtCodigoCliente.Text := formmenuprincipal.claveelegida;
      txtcodigocomercial.setfocus;
    end;
  end;
end;

procedure TFormVentaG.FormShow(Sender: TObject);
begin
  if formmenuprincipal.leBoolINI ('Aplicacion', cintroducireuros, False) then //Euros
    BCambioClick(nil);
  datos.tcomercial.open;
  datos.tcliente.open;
  datos.taparato.open;
  TxtFecha.setfocus;
  if formmenuprincipal.accion = 'nuevo' then
  begin
    caption := 'Nuevo ' + ventana + '...';;
    datos.tventa.Active := true;
    datos.tventa.Insert;
    datos.TventaFecha.value := formmenuprincipal.VTFechaTrabajo;
    datos.TVentaCobrada.value := False;    
  end;
  if formmenuprincipal.accion = 'modificar' then
  begin
    caption := 'Modificar ' + ventana + '...';
  end;
  if formmenuprincipal.accion = 'zoom' then
  begin
    datos.tventa.Active := true;
    datos.tventa.locate ('Codigo', formmenuprincipal.codigo,[]);
    caption := 'Visualizar ' + ventana + '...';
    BSeleccionarCliente.Visible := false;
    BSeleccionarComercial.Visible := false;
    BSeleccionarFecha.Visible := false;
    BSeleccionarFechaInstalacion.visible := false;
    bseleccionaraparato.visible := false;
    baceptar.Visible := false;
    bcancelar.SetFocus;
  end;
end;

procedure TFormVentaG.TxtCPChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txtcp.text) = 5 then
      txttelefono.setfocus;
  end;}
end;

procedure TFormVentaG.TxtTelefonoChange(Sender: TObject);
begin
{  if formmenuprincipal.accion <> 'zoom' then
  begin
    if length(txttelefono.text) = 9 then
      opIVA.setfocus;
  end;}
end;

procedure TFormVentaG.TxtCodigoClienteKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (key = '+') and (FormMenuPrincipal.accion <> 'zoom') then
  begin
    key := chr(0);
    BSeleccionarClienteclick(nil);
  end;
end;

procedure TFormVentaG.BSeleccionarComercialClick(Sender: TObject);
begin
  txtcodigocomercial.setfocus;
  application.createform(tformseleccion, formseleccion);
  Formseleccion.Caption := 'Seleccin de comercial...';
  formseleccion.tag := 10;
  formseleccion.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
  begin
    if FormMenuPrincipal.claveelegida <> '' then
    begin
      TxtCodigoComercial.Text := formmenuprincipal.claveelegida;
      Perform(WM_NEXTDLGCTL, 0, 0);
    end;
  end;
end;

procedure TFormVentaG.TxtCodigoComercialKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (key = '+') and (FormMenuPrincipal.accion <> 'zoom') then
  begin
    key := chr(0);
    BSeleccionarComercialclick(nil);
  end;
end;

procedure TFormVentaG.BSeleccionarFechaClick(Sender: TObject);
begin
  application.createform(tformCalendario, formCalendario);
  formCalendario.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    if FormMenuPrincipal.claveelegida <> '' then
      TxtFecha.Text := formmenuprincipal.claveelegida;
end;

procedure TFormVentaG.TxtFechaKeyPress(Sender: TObject; var Key: Char);
begin
  if (key = '+') and (FormMenuPrincipal.accion <> 'zoom') then
  begin
    key := chr(0);
    BSeleccionarfechaclick(nil);
  end;
end;

procedure TFormVentaG.TxtImporteKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
  if key = '+' then
  begin
    BCambioClick(nil);
    key := #0;
  end;
end;

procedure TFormVentaG.BSeleccionarFechaInstalacionClick(Sender: TObject);
begin
  application.createform(tformCalendario, formCalendario);
  formCalendario.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    if FormMenuPrincipal.claveelegida <> '' then
      TxtFechaInstalacion.Text := formmenuprincipal.claveelegida;
end;

procedure TFormVentaG.BSeleccionarAparatoClick(Sender: TObject);
begin
  txtcodigoaparato.setfocus;
  application.createform(tformseleccion, formseleccion);
  Formseleccion.Caption := 'Seleccin de aparatos...';
  formseleccion.tag := 30;
  formseleccion.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
  begin
    if FormMenuPrincipal.claveelegida <> '' then
    begin
      TxtCodigoAparato.Text := formmenuprincipal.claveelegida;
      Perform(WM_NEXTDLGCTL, 0, 0);
    end;
  end;
end;

procedure TFormVentaG.TxtCodigoAparatoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (key = '+') and (FormMenuPrincipal.accion <> 'zoom') then
  begin
    key := chr(0);
    BSeleccionarAparatoClick(nil);
  end;
end;

procedure TFormVentaG.TxtFechaInstalacionKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (key = '+') and (FormMenuPrincipal.accion <> 'zoom') then
  begin
    key := chr(0);
    BSeleccionarFechaInstalacionClick(nil);
  end;
end;

procedure TFormVentaG.BCambioClick(Sender: TObject);
begin
  if uppercase(LMoneda.caption) = uppercase('Pesetas') then
  begin
    TxtImporte.dataField := 'ImporteE';
    IPeseta.Visible := false;
    IEuro.Visible := true;
    LMoneda.Caption := 'Euros';
  end
  else
  begin
    TxtImporte.dataField := 'Importe';
    IPeseta.Visible := true;
    IEuro.Visible := false;
    LMoneda.Caption := 'Pesetas';
  end;
  txtimporte.SelectAll;
  txtimporte.SetFocus;
end;

end.
