unit UnidadLocalizar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, db;

type
  TFormLocalizar = class(TForm)
    GComercial: TGroupBox;
    Op2: TRadioButton;
    Op1: TRadioButton;
    TxtBuscar: TEdit;
    Label1: TLabel;
    BCancelar: TBitBtn;
    Op3: TRadioButton;
    Op4: TRadioButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure BCancelarClick(Sender: TObject);
    procedure TxtBuscarChange(Sender: TObject);
    procedure TxtBuscarKeyPress(Sender: TObject; var Key: Char);
    procedure Op2KeyPress(Sender: TObject; var Key: Char);
    procedure Op1KeyPress(Sender: TObject; var Key: Char);
    procedure Op3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormLocalizar: TFormLocalizar;

implementation

uses UnidadDatos;

{$R *.DFM}

function esNumero (numero : string) : boolean;
begin
  try
    strtoint(numero);
    result := true;
  except
    result := false;
  end;
end;


procedure TFormLocalizar.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  screen.Cursor := crDefault;
  action := cafree;
end;

procedure TFormLocalizar.FormShow(Sender: TObject);
begin
  if tag = 10 then //comerciales
  begin
    Op1.Visible := true;
    Op1.caption := '&Nombre';
    Op2.Visible := true;
    Op2.caption := 'N&IF';
    Op3.Visible := true;
    Op3.caption := 'Cdig&o';
    Op4.Visible := true;
    Op4.caption := 'T&elfono';
    caption := 'Localizar comerciales...';
    GComercial.Visible := true;
  end;
  if tag = 20 then //usuarios
  begin
    caption := 'Localizar usuarios...';
    Op1.Visible := true;
    Op1.caption := '&Nombre';
    Op2.Visible := true;
    Op2.caption := 'Cdig&o';
    GComercial.Visible := true;
  end;
  if tag = 30 then //aparatos
  begin
    Op1.Visible := true;
    Op1.caption := '&Descripcin';
    Op2.Visible := true;
    Op2.caption := 'Cdig&o';
    caption := 'Localizar aparatos...';
    GComercial.Visible := true;
  end;
  if tag = 40 then //empresas
  begin
    caption := 'Localizar empresas...';
    Op1.Visible := true;
    Op1.caption := '&Nombre';
    Op2.Visible := true;
    Op2.caption := 'Cdig&o';
    GComercial.Visible := true;
  end;
  if tag = 50 then //clientes
  begin
    Op1.Visible := true;
    Op1.caption := '&Nombre';
    Op2.Visible := true;
    Op2.caption := 'N&IF/CIF';
    Op3.Visible := true;
    Op3.caption := 'Cdig&o';
    Op4.Visible := true;
    Op4.caption := 'T&elfono 1';
    caption := 'Localizar clientes...';
    GComercial.Visible := true;
  end;
  if tag = 60 then //cobros
  begin
    Op1.Visible := true;
    Op1.caption := 'Cdig&o';
    Op2.Visible := true;
    Op2.caption := 'Co&mercial';
    Op3.Visible := true;
    Op3.caption := 'Clien&te';
    Op4.Visible := true;
    Op4.caption := 'T&ipo de cobro';
    caption := 'Localizar cobro...';
    GComercial.Visible := true;
  end;
  if tag = 70 then //plus
  begin
    Op1.Visible := true;
    Op1.caption := '&Descripcin';
    Op2.Visible := true;
    Op2.caption := 'Cdig&o';
    Op3.Visible := true;
    Op3.caption := 'D&esde n de ventas';
    Op4.Visible := true;
    Op4.caption := '&Hasta n de ventas';
    caption := 'Localizar plus...';
    GComercial.Visible := true;
  end;
  if tag = 80 then //ventas
  begin
    Op1.Visible := true;
    Op1.caption := 'Cdig&o';
    Op2.Visible := true;
    Op2.caption := 'Co&mercial';
    Op3.Visible := true;
    Op3.caption := 'Clien&te';
    Op4.Visible := true;
    Op4.caption := '&Aparato';
    caption := 'Localizar venta...';
    GComercial.Visible := true;
  end;
  if tag = 90 then //gastos
  begin
    Op1.Visible := true;
    Op1.caption := 'Cdig&o';
    Op2.Visible := true;
    Op2.caption := 'Co&mercial';
    Op3.Visible := true;
    Op3.caption := '&Descripcin';
    caption := 'Localizar gasto...';
    GComercial.Visible := true;
  end;
  if tag = 100 then //extras
  begin
    Op1.Visible := true;
    Op1.caption := 'Cdig&o';
    Op2.Visible := true;
    Op2.caption := 'Co&mercial';
    Op3.Visible := true;
    Op3.caption := '&Descripcin';
    caption := 'Localizar extra...';
    GComercial.Visible := true;
  end;
  if tag = 110 then //facturas
  begin
    Op1.Visible := true;
    Op1.caption := 'Nmer&o';
    Op2.Visible := true;
    Op2.caption := 'Co&mercial';
    Op3.Visible := true;
    Op3.caption := 'Conc&epto';
    caption := 'Localizar factura...';
    GComercial.Visible := true;
  end;
end;

procedure TFormLocalizar.BCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TFormLocalizar.TxtBuscarChange(Sender: TObject);
begin
  if tag = 10 then  //comerciales
  begin
    //por nif
    if Op2.Checked then
      datos.TCComercial.Locate('NIF', txtbuscar.text,[lopartialkey,
          locaseinsensitive]);
    //por nombre
    if Op1.Checked then
      datos.TCComercial.Locate('Nombre', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
    //por codigo
    if Op3.Checked then
      datos.TCComercial.Locate('Codigo', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
    //por telfono
    if Op4.Checked then
      datos.TCComercial.Locate('Telefono', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
  end;
  if tag = 20 then  //usuarios
  begin
    //por nombre
    if Op1.Checked then
      datos.TCUsuario.Locate('Nombre', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
    //por cdigo
    if Op2.Checked then
      datos.TCUsuario.Locate('Codigo', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
  end;
  if tag = 40 then  //empresas
  begin
    if (Op2.Checked) then
    begin
      if not esNumero(txtbuscar.text) then
        Op1.Checked := true;
    end;
    if (Op1.Checked) and (Length(txtbuscar.text) = 1) then
    begin
      if esNumero(txtbuscar.text) then
        Op2.Checked := true;
    end;
    if Op2.Checked then  //codigo
      datos.tcempresa.Locate('Codigo', txtbuscar.text,[lopartialkey,
          locaseinsensitive]);
    if Op1.Checked then  //nombre
      datos.tcempresa.Locate('NombreEmpresa', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
  end;
  if tag = 30 then  //aparatos
  begin
    //por codigo
    if Op2.Checked then
      datos.TCAparato.Locate('Codigo', txtbuscar.text,[lopartialkey,
          locaseinsensitive]);
    //por descripcion
    if Op1.Checked then
      datos.TCAparato.Locate('Nombre', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
  end;
  if tag = 50 then  //clientes
  begin
    //por nif
    if Op2.Checked then
      datos.TCCliente.Locate('NIF', txtbuscar.text,[lopartialkey,
          locaseinsensitive]);
    //por nombre
    if Op1.Checked then
      datos.TCCliente.Locate('Nombre', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
    //por codigo
    if Op3.Checked then
      datos.TCCliente.Locate('Codigo', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
    //por telfono
    if Op4.Checked then
      datos.TCCliente.Locate('Telefono1', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
  end;
  if tag = 60 then  //cobros
  begin
    //por codigo
    if Op1.Checked then
    begin
      try
        datos.TCCobro.Locate('Codigo', txtbuscar.text, [lopartialkey,
            locaseinsensitive]);
      except
        //silenciosa
      end;
    end;
    //por comercial
    if Op2.Checked then
      datos.TCCobro.Locate('Comercial', txtbuscar.text,[lopartialkey,
          locaseinsensitive]);
    //por cliente
    if Op3.Checked then
      datos.TCCobro.Locate('cliente', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
    //por tipo de cobro
    if Op4.Checked then
      datos.TCCobro.Locate('TipoCobro', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
  end;
  if tag = 70 then  //plus
  begin
    //por nombre
    if Op1.Checked then
      datos.TCPlus.Locate('Nombre', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
    //por codigo
    if Op2.Checked then
      datos.TCPlus.Locate('Codigo', txtbuscar.text,[lopartialkey,
          locaseinsensitive]);
    if Op3.Checked then     //por desde n ventas
    begin
      try
        datos.TCPlus.Locate('NVentasD', txtbuscar.text, [lopartialkey,
            locaseinsensitive]);
      except
        //silenciosa
      end;
    end;
    if Op4.Checked then //por hasta n ventas
    begin
      try
        datos.TCPlus.Locate('NVentasH', txtbuscar.text, [lopartialkey,
            locaseinsensitive]);
      except
        //silenciosa
      end;
    end;
  end;
  if tag = 80 then  //ventas
  begin
    //por codigo
    if Op1.Checked then
    begin
      try
        datos.TCVenta.Locate('Codigo', txtbuscar.text, [lopartialkey,
            locaseinsensitive]);
      except
        //silenciosa
      end;
    end;
    //por comercial
    if Op2.Checked then
      datos.TCVenta.Locate('Comercial', txtbuscar.text,[lopartialkey,
          locaseinsensitive]);
    //por cliente
    if Op3.Checked then
      datos.TCVenta.Locate('cliente', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
    //por Aparato
    if Op4.Checked then
      datos.TCVenta.Locate('Aparato', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
  end;
  if tag = 90 then  //gastos
  begin
    //por codigo
    if Op1.Checked then
    begin
      try
        datos.TCComercialGasto.Locate('Codigo', txtbuscar.text, [lopartialkey,
            locaseinsensitive]);
      except
        //silenciosa
      end;
    end;
    //por comercial
    if Op2.Checked then
      datos.TCComercialGasto.Locate('Comercial', txtbuscar.text,[lopartialkey,
          locaseinsensitive]);
    //por descripcin
    if Op3.Checked then
      datos.TCComercialGasto.Locate('Nombre', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
  end;
  if tag = 100 then  //extras
  begin
    //por codigo
    if Op1.Checked then
    begin
      try
        datos.TCExtra.Locate('Codigo', txtbuscar.text, [lopartialkey,
            locaseinsensitive]);
      except
        //silenciosa
      end;
    end;
    //por comercial
    if Op2.Checked then
      datos.TCExtra.Locate('Comercial', txtbuscar.text,[lopartialkey,
          locaseinsensitive]);
    //por descripcin
    if Op3.Checked then
      datos.TCExtra.Locate('Nombre', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
  end;
  if tag = 110 then  //facturas
  begin
    //por codigo
    if Op1.Checked then
    begin
      try
        datos.TCFactura.Locate('Codigo', txtbuscar.text, [lopartialkey,
            locaseinsensitive]);
      except
        //silenciosa
      end;
    end;
    //por comercial
    if Op2.Checked then
      datos.TCFactura.Locate('Comercial', txtbuscar.text,[lopartialkey,
          locaseinsensitive]);
    //por descripcin
    if Op3.Checked then
      datos.TCFactura.Locate('Concepto', txtbuscar.text, [lopartialkey,
          locaseinsensitive]);
  end;
end;

procedure TFormLocalizar.TxtBuscarKeyPress(Sender: TObject; var Key: Char);
begin
  if key = char(13) then
  begin
    key := #0;
    BCancelarClick(nil);
  end;
end;

procedure TFormLocalizar.Op2KeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(13) then
    TxtBuscar.setfocus;
end;

procedure TFormLocalizar.Op1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = chr(13) then
    TxtBuscar.setfocus;
end;

procedure TFormLocalizar.Op3Click(Sender: TObject);
begin
  txtbuscar.setfocus;
end;

end.
