unit UnidadReorganizar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons, ExtCtrls, dbtables, bde, db;

type
  TFormReorganizar = class(TForm)
    OpCompactar: TCheckBox;
    PCompactar: TProgressBar;
    Panel1: TPanel;
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    TTabla: TTable;
    OpReindexar: TCheckBox;
    PReindexar: TProgressBar;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BAceptarClick(Sender: TObject);
    procedure BCancelarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormReorganizar: TFormReorganizar;

  procedure Compactar (const ADatabase, ATable:String);
  procedure Reindexar (Tabla : ttable);
  
implementation

uses UnidadDatos, UnidadMenuPrincipal;

{$R *.DFM}

procedure TFormReorganizar.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  screen.Cursor := crdefault;
  action := cafree;
end;

procedure Reindexar (Tabla : ttable);
begin
  Check (dbiregenindexes (tabla.Handle));
end;
procedure Compactar (const ADatabase, ATable:String);
var
  ADB:TDataBase;
  SaveKC:Boolean;
  PdxStruct: CRTblDesc;
begin
  with TTable.Create(nil) do
  try
    DataBaseName:=ADataBase;
    TableName:=ATable;
    Exclusive:=True;
    Open;
    ADB:=DataBase;
    SaveKC:=ADB.KeepConnection;
    ADB.KeepConnection:=True;
    try
      Close;
      FillChar(PdxStruct,SizeOf(PdxStruct),0);
      StrPCopy(PdxStruct.szTblName,ATable);
      PdxStruct.bPack:=True;
      Check(DbiDoRestructure(ADB.Handle,1,@PdxStruct,nil,nil,nil,False));
    finally
      ADB.KeepConnection:=SaveKC;
    end;
  finally
    Free;
  end;
end;

procedure TFormReorganizar.BAceptarClick(Sender: TObject);
begin
  datos.DB.close;
  if OpCompactar.Checked then
  begin
    PCompactar.Position := 0;
    PCompactar.Max := 10;
    PCompactar.Min := 0;
    PCompactar.Visible := true;
    PCompactar.Position := 1;
    compactar ('AComisiones', 'aparato.db');
    PCompactar.Position := 2;
    compactar ('AComisiones', 'comercial.db');
    PCompactar.Position := 3;
    compactar ('AComisiones', 'gasto.db');
    PCompactar.Position := 4;
    compactar ('AComisiones', 'extra.db');
    PCompactar.Position := 5;
    compactar ('AComisiones', 'factura.db');
    PCompactar.Position := 6;
    compactar ('AComisiones', 'cliente.db');
    PCompactar.Position := 7;
    compactar ('AComisiones', 'plus.db');
    PCompactar.Position := 8;
    compactar ('AComisiones', 'cobro.db');
    PCompactar.Position := 9;
    compactar ('AComisiones', 'venta.db');
    PCompactar.Position := 10;
  end;
  if OpReindexar.Checked then
  begin
    PReindexar.Position := 0;
    PReindexar.Max := 9;
    PReindexar.Min := 0;
    PReindexar.Visible := true;
    PReindexar.Position := 1;
    with ttabla do
    begin
      close;
      exclusive := true;
      TableName := 'Aparato.db';
      open;
      reindexar (ttabla);
      PReindexar.Position := 2;
      close;
      TableName := 'comercial.db';
      open;
      reindexar (ttabla);
      PReindexar.Position := 3;
      close;
      TableName := 'gasto.db';
      open;
      reindexar (ttabla);
      PReindexar.Position := 4;
      close;
      TableName := 'extra.db';
      open;
      reindexar (ttabla);
      PReindexar.Position := 5;
      close;
      TableName := 'factura.db';
      open;
      reindexar (ttabla);
      PReindexar.Position := 6;
      close;
      TableName := 'cliente.db';
      open;
      reindexar (ttabla);
      PReindexar.Position := 7;
      close;
      TableName := 'plus.db';
      open;
      reindexar (ttabla);
      PReindexar.Position := 8;
      close;
      TableName := 'cobro.db';
      open;
      reindexar (ttabla);
      PReindexar.Position := 9;
    end;
  end;
  formmenuprincipal.msInfo ('Proceso finalizado correctamente.', 'Informacin...');
  close;
end;

procedure TFormReorganizar.BCancelarClick(Sender: TObject);
begin
  close;
end;

end.
