unit UnidadUsuarios;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, inifiles,variants;

type
  TFormUsuarios = class(TForm)
    PopupMenu1: TPopupMenu;
    ActionList1: TActionList;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ActControlarSuprimir: TAction;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ActRefrescar: TAction;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ActCerrar: TAction;
    Tabla: TDBGrid;
    ActImprimir: TAction;
    Aadir1: TMenuItem;
    Eliminar1: TMenuItem;
    Modificar1: TMenuItem;
    N1: TMenuItem;
    Refrescar1: TMenuItem;
    N2: TMenuItem;
    Cerrar1: TMenuItem;
    ToolButton8: TToolButton;
    ActBuscar: TAction;
    ToolButton9: TToolButton;
    Buscar1: TMenuItem;
    Imprimir1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ActControlarSuprimirExecute(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);

    procedure ordenar (campo : string; campoFijo : string);

    procedure ActImprimirExecute(Sender: TObject);
    procedure ActBuscarExecute(Sender: TObject);
    procedure TablaTitleClick(Column: TColumn);
  private
    campoOrdenado : string;
    nombreCampoOrdenado : string;
    { Private declarations }
  public
    { Public declarations }
  end;


var
  FormUsuarios: TFormUsuarios;
const
  ventana = 'Usuario';
  ventanas = 'Usuarios';
  segCampo = 'Nombre';
  implementation

uses UnidadMenuPrincipal, UnidadImprimir,
  UnidadLocalizar, UnidadDatos, UnidadGUsuario;

{$R *.DFM}

var
  fp : tformmenuprincipal;
procedure TFormUsuarios.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  i:integer;
begin
  //Guardar el ancho de las columnas y configuracin
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    WriteString('Tabla ' + ventanas, cCLugar, datos.TCUsuarioCodigo.value);
    writestring('Tabla ' + ventanas, cCOrdenar, campoOrdenado);
    writestring('Tabla ' + ventanas, ccTituloOrdenar, nombreCampoOrdenado);
    for I := 0 to tabla.Columns.Count - 1 do
    begin
      with tabla.Columns.Items[I] do
        WriteInteger('Tabla ' + ventanas, FieldName, Width);
    end;
  finally
    Free;
  end;
  try
   datos.tusuario.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TFormUsuarios.FormShow(Sender: TObject);
var
  I : Integer;
  lugar, ruta : string;
begin
  datos.tusuario.close;
  datos.TCUsuario.close;
  if formmenuprincipal.vtservidor = 1 then
    ruta := extractfilepath(application.exename)
  else
    ruta := formmenuprincipal.vtrutaservidor;
  datos.tusuario.databasename := ruta;
  datos.tcusuario.databasename := ruta;

  cb.visible := formmenuprincipal.vtmostrarbbventanas;
  bb.flat := formmenuprincipal.vtflat;

  //si hay que restablecer la ventana segn la ltima vez
  if FormMenuPrincipal.leBoolINI ('Aplicacion', cGuardarVentanas, false) then
  begin
    with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
    try
      lugar := readString('Tabla ' + ventanas, cclugar, '0');
      campoOrdenado := readstring('Tabla ' + ventanas, ccordenar, 'Codigo');
      nombreCampoOrdenado := readstring('Tabla ' + ventanas, ccTituloOrdenar, 'Cdigo');
      if campoOrdenado = '' then
        campoOrdenado := 'Codigo';
      if nombreCampoOrdenado = '' then
        nombreCampoOrdenado := 'Cdigo';
    finally
      Free;
    end;

    ordenar(campoOrdenado, segCampo);
    Datos.TCUsuario.Locate ('Codigo', lugar, []);

  end
  else
  begin
    campoOrdenado := 'Codigo';
    ordenar(campoOrdenado, segCampo);
    nombreCampoOrdenado := 'Cdigo';
  end;

  //ancho de columnas
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    for I := 0 to tabla.Columns.Count - 1 do
      with tabla.Columns.Items[I] do
        Width := ReadInteger('Tabla ' + ventanas, FieldName, Width);
  finally
    Free;
  end;

  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas + ' (ordenado por ' + nombrecampoordenado + ')';
  screen.cursor := crdefault;
end;

procedure tFormUsuarios.ordenar (campo : string; campoFijo : string);
var
  lugar : string;
begin
  lugar := '';
  With datos.TCUsuario do
  begin
    if Active then
    begin
      Refresh;
      if RecordCount > 0 then
        lugar := fieldbyname('Codigo').value;
    end;
    close;
    if FormMenuPrincipal.vtservidor = 1 then
      databasename := ExtractFilePath(Application.exename)
    else
      databasename := FormMenuPrincipal.vtrutaservidor;
    sql.clear;
    sql.add('SELECT  *');
    sql.add('FROM ' + ventana);
    sql.add('ORDER BY ' + campo + ',' + campoFijo);
    try
      open;
   // ExecSQL;
    except
      raise;
    end;
    if lugar <> '' then
      locate ('Codigo', lugar,[]);
  end;
end;

procedure TFormUsuarios.ActControlarSuprimirExecute(Sender: TObject);
begin
  //
end;

procedure TFormUsuarios.ActNuevoExecute(Sender: TObject);
begin
  if fp.ComprobarUsuario('altas/bajas', false) then
  begin
    formmenuprincipal.accion := 'nuevo';
    application.createform(tformusuariog, formusuariog);
    formusuariog.ShowModal;
    ActRefrescarExecute(nil);
  end;
end;

procedure TFormUsuarios.ActEliminarExecute(Sender: TObject);
var
  nombre : String;
begin
  if datos.TCUsuario.RecordCount <= 0 then
    fp.msInfo ('No hay usuarios para eliminar.', 'Eliminar...')
  else
  begin
    if datos.TCUsuarioCodigo.Value = FormMenuPrincipal.VTCodigoUsuario then
      fp.msError ('No se puede eliminar el usuario activo.', 'Error...')
    else
    begin
      if datos.TCUsuarioTipo.Value = 'Administrador' then
        fp.msInfo ('No se puede eliminar el usuario Administrador.', 'Eliminar...')
      else
      begin
        datos.tusuario.Active := true;
        datos.tusuario.locate('Codigo',
            datos.tcusuario.fieldbyname('Codigo').value, []);
        if not varisnull(datos.TUsuarioNombre.Value) then
          nombre := datos.TUsuarioNombre.Value
        else
          nombre := '';
        if fp.msSi ('Est seguro que desea eliminar el usuario: ' +
            nombre + '?', 'Eliminar...') then
        begin
          try
            datos.TUsuario.delete;
            ActRefrescarExecute(nil);
          except
            raise;
          end;
        end;
      end;
    end;
  end;
end;

procedure TFormUsuarios.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure TFormUsuarios.ActModificarExecute(Sender: TObject);
begin
  if datos.TCUsuario.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario('modificacion', false) then
    begin
      if not varisnull(datos.TCUsuarioCodigo.value) then
      begin
        formmenuprincipal.accion := 'modificar';
        datos.tusuario.open;
        datos.TUsuario.locate ('Codigo',
            datos.TCUsuario.fieldbyname('Codigo').value,[]);
        datos.TUsuario.edit;
        application.createform(tformusuariog, formusuariog);
        formusuariog.ShowModal;
        ActRefrescarExecute(nil);
      end
      else
        fp.msError ('Atencin, el ' + ventana + ' actual no tiene cdigo, ' +
            'elimnelo antes de continuar.','Error...');
    end;
  end;
end;

procedure TFormUsuarios.TablaDblClick(Sender: TObject);
begin
  ActModificarExecute(nil);
end;

procedure TFormUsuarios.ActRefrescarExecute(Sender: TObject);
begin
  ordenar(campoOrdenado, segCampo);
end;

procedure TFormUsuarios.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TFormUsuarios.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TFormUsuarios.ActImprimirExecute(Sender: TObject);
begin
  if datos.TCUsuario.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if fp.ComprobarUsuario ('localizar', false) then
    begin
      application.createform(tformImprimir, formImprimir);
      formimprimir.Tag := 20;
      formImprimir.showmodal;
    end;
  end;
end;

procedure TFormUsuarios.ActBuscarExecute(Sender: TObject);
begin
  if datos.TCUsuario.RecordCount <= 0 then
    fp.msInfo ('No hay datos.', 'Informacin...')
  else
  begin
    if  fp.ComprobarUsuario ('localizar', false) then
    begin
      application.createform(tformLocalizar, formLocalizar);
      FormLocalizar.Tag := 20;
      formLocalizar.showmodal;
    end;
  end;
end;

procedure TFormUsuarios.TablaTitleClick(Column: TColumn);
begin
  campoOrdenado := column.fieldname;
  nombreCampoOrdenado := Column.Title.Caption;
  caption := ventanas + ' (ordenado por ' + Column.Title.Caption + ')';
  ordenar (campoOrdenado, segCampo);
end;

end.
